;******************************** FLI *******************************
;*                 a 4Ko intro by Real Time in 1995                 *
;*                 http://www.fairyengine.com                       *
;********************************************************************

                .MODEL  Small,Pascal

NbSqr           Equ     6500            ; carres pour les fractales             - squares for fractals
AltiSize        Equ     8222            ; taille tableau altitudes goutte       - size of array for drop's heights
RaciSize        Equ     2533            ; idem pour tableau racines             - same thing for square roots array
MemNeeded       Equ     4096+4096+4096+4096+3251+1355+3480+2000+512
;                                         nb paragraphes (=16 octets) memoire   - nb memory paragraphs (= 16 bytes)
;                       Ecr_Virtu+Map+MapGoutte+Randoms+Carres+Alti+Carres2+Feu+SinGoutte


                .DATA
EVENDATA
Pas             DD      190             ; pas de la Mandelbrot                  - Mandelbrot step
ptx             DD     -158000          ; position en x dans Julia              - x position in Julia
dtx             DD      1000            ; deplacement en x Julia                - x move for Julia

LdW1            DD      10001-100       ; ligne 0 (100) MandelCopro             - 0 (100) line MandelCopro
LdW3            DD      32768           ; diviseur MandelCopro                  - MandelCopro divisor
LdW4            DD      4               ; module max MandelCopro                - MandelCopro max value

CaseBuildLines  DB      30,4,0,10       ; [si],ptg,limg,limd
                DB      71,13,11,17
                DB      131,20,18,22

CaseMoveBoule   DW      -100,30,225     ; DeplX

TrajJulia       DW      1000,0,67,      1000,1000,25,   1000,0,18
                DW      1000,1000,35,   1000,0,10,      1000,-1000,15
                DW      1000,0,16,      0,-1000,500

OffNew8         DW      Offset NewInt8  ; int8 = timer
SegNew8         DW      Seg NewInt8
OffNew9         DW      Offset NewInt9  ; int9 = keyboard
SegNew9         DW      Seg NewInt9

BouleY          DW      100*256         ; position boule en y                   - ball's y position
Cmpt            DW      132             ; compteur                              - counter
Xg              DW      20              ; fenetre noire Mandelbrot              - Mandelbrot's black window
Xd              DW      309
Yh              DW     -20
Yb              DW      219
NbRep           DW      67              ; nombre de repetitions trajectoire     - nb path loops
CentrX          DW      128             ; position dans le land                 - position in landscape
CentrY          DW      128

FinLett         DB      1               ; lettre terminee                       - finished letter

Fli             DB      40,60,30,60,30,70,20,70,20,30                   ; F
                DB      50,30,50,40,30,40,30,50,40,50,40,60
                DB      110,70,70,70,70,30,80,30,80,60,110,60,110,70    ; L
                DB      140,70,130,70,130,30,140,30,140,70              ; I

NotEnoughMem    DB      'NOT enough memory$'
CodeBy          DB      '(c) 1995 by MYTHOS / '
RealTime        DB      'REAL  TIME$'
Presents        DB      'presents$'


                .DATA?
EVENDATA
firstvar        DD      ?

Carres          DD      ?               ; table des carres (fractales)          - array of squares (fractals)
Carres2         DD      ?               ; table des carres (goutte)             - array of squares (drop)
Ecr_Virtu       DD      ?               ; ecran virtuel                         - virtual screen
Map             DD      ?               ; map pour le land                      - landscape's map
MapGoutte       DD      ?               ; map pour la goutte                    - drop's map
Feu             DD      ?               ; tableau 160x100 flammes               - flames' 160*x100 array
SinGoutte       DD      ?               ; 4096 sinus
Alti            DD      ?               ; pointeurs de la goutte                - drop's pointers
Randoms         DD      ?               ; table de nbres aleatoires (words)     - array of random values

pty             DD      ?               ; position en y dans Julia              - y position in Julia
dty             DD      ?               ; deplacement en y Julia                - y move for Julia
LdW2            DD      ?               ; col MandelCopro *32768

HSec            DW      ?               ; compteur timer                        - timer counter
SinCos          DW      360*2   DUP (?) ; table de sinus et cosinus *256        - array of sines & cosines *256
Lines           DW      20*4    DUP (?) ; lettres de feu                        - fire letters
Dir             DW      4       DUP (?) ; direction du trace                    - drawing direction
DeplX           DW      ?               ; deplacement correspondant             - corresponding move
DeplY           DW      ?
BouleX          DW      ?               ; position boule en x                   - ball's x position
RandPos         DW      ?               ; index dans table randoms              - randoms array's index

Teta            DW      ?
TetaRets        DB      ?               ; nb retours Julia & land               - nb vbls Julia & landscape

PtTraj          DB      ?               ; position dans TrajJulia               - position in TrajJulia
Horiz           DB      160     DUP (?) ; horizon flottant du land              - landscape's line of sight
Dac             DB      256*3   DUP (?) ; palette                               - 
ptd             DB      ?               ; pt droit segment en cours -| dans     - right point current segment -| in
ptg             DB      ?               ; id gauche                  | cet      - left                         | this
limg            DB      ?               ; num pt gauche stop         | ordre    - left stop point number       | order
limd            DB      ?               ; id droit                  -| !!!      - right                       -| !!!
segg            DB      ?               ; num segment gauche en cours           - current left segment number
segd            DB      ?               ; id droit                              -         right
Start           DB      ?               ; boolean : commencer lettre            - boolean : start letter
ATracer         DB      ?               ; nbre segments a tracer                - nb segments to draw

Boule           DB      ?               ; nbre de boules                        - nb balls
Lettre          DB      ?               ; num lettre a tracer                   - number of letter to draw

_esc            DB      ?               ; escape pressed
_enter          DB      ?               ; enter  pressed

lastvar         DB      ?


                .CODE
                .386
                 LOCALS

;********************************************************************
; procedures generales - general procedures
;********************************************************************

IntroFli        Proc    Near

;*** MEM ***
                mov     ax,@data
                mov     ds,ax

                mov     dx,es                   ; PSP
                mov     bx,ss
                mov     cx,sp
                shr     cx,4
                add     bx,cx
                sub     bx,dx
                inc     bx
                mov     ah,4Ah
                int     21h                     ; SetFree

                call    ReserveMem
                jc      @@MemFailed

@@SetNewClav:   mov     bx,4
                call    SetNewInt
@@SetNewTimer:  xor     bl,bl
                mov     cx,0429h                ; 1065 (Freq:16*70)
                call    SetNewInt

                mov     ax,03h
                int     10h
                les     di,[MapGoutte]          ; map de la goutte              - drop's map
                mov     cx,Offset RealTime
                mov     dx,0B24h                ; lig 11, col 36                - row 11, col 36
                call    SetMessage
                mov     cx,Offset Presents
                mov     dx,0F25h                ; lig 15, col 37                - row 15, col 37
                call    SetMessage
                mov     [_enter],bh             ; 0

;*** titre-feu ***
                call    InitFeu
@@Feu:          call    ProcessFlammes
                mov     bl,1
                call    WaitAndCopy             ; renvoie cx=nb de retours      - returns cx=nb of vbls
@@AvanceFeu:    push    cx                      ; debut synchro timer           - start of timer synchro
                call    MoveBoule
                cmp     [FinLett],1
                je      @@NoLines
                call    BuildLines
@@NoLines:      mov     al,[Boule]
                cmp     al,5
                jbe     @@TraceFeu
                and     al,1
                jnz     @@NoTraceFeu
@@TraceFeu:     call    TraceLinesFeu
@@NoTraceFeu:   pop     cx
                cmp     [Boule],18
                jae     @@Mandel
                loop    @@AvanceFeu             ; fin synchro timer             - end of timer synchro
                call    TestKeys
                jz      @@Feu                   ; z=no key
                jc      @@Quitte4Ko             ; c=esc

;*** dzoom ***
@@Mandel:       call    BuildSqrMandel
@@Dezoom:       call    Mand_Julia
                mov     bl,3                    ; nb retours mini               - minimal nb vbls
                call    WaitAndCopy
@@AvanceZoomM:  dec     [Cmpt]
                mov     ax,word ptr [Pas]
                shr     ax,5
                add     word ptr [Pas],ax
                mov     ax,[Cmpt]
                mov     bx,ax
                shr     ax,5
                add     [Xg],ax
                sub     [Xd],ax
                cmp     bx,110
                jnb     @@WindowOk
                shr     ax,1
                sub     [Xg],ax
                add     [Xd],ax
@@WindowOk:     mov     ax,bx
                mov     ch,48
                div     ch
                xor     ah,ah
                add     [Yh],ax
                sub     [Yb],ax
                or      bx,bx
                jz      @@Julia
                sub     cl,4
                jnc     @@AvanceZoomM           ; synchro timer
                call    TestKeys
                jz      @@Dezoom
                jc      @@Quitte4Ko

;*** Julia ***
@@Julia:        call    InitLand
                call    InitJulia
@@ZoomJulia:    call    Mand_Julia
                mov     bl,2
                call    WaitAndCopy
@@AvanceZoomJ:  add     [Pas],20
                cmp     [Pas],678
                jae     @@InitMove
                sub     cl,3
                jnc     @@AvanceZoomJ           ; synchro timer
                call    TestKeys
                jz      @@ZoomJulia
                jc      @@Quitte4Ko

@@InitMove:     mov     [Pas],678
                call    MoveAndWait
                mov     [TetaRets],cl           ; sauver nb retours             - save nb vbls
@@MoveJulia:    call    MoveAndWait
                mov     cl,[TetaRets]
@@AvanceMoveJ:  mov     eax,[Dtx]
                add     [Ptx],eax
                mov     eax,[Dty]
                add     [Pty],eax
                dec     [NbRep]
                jnz     @@Encore

                mov     bl,[PtTraj]
                inc     bl
                and     bl,7
                jz      @@InitLand
                mov     [PtTraj],bl
                xor     bh,bh
                imul    bx,6
                add     bx,Offset [TrajJulia]
                mov     ax,[bx]
                cwde
                mov     [Dtx],eax
                mov     ax,[bx+2]
                cwde
                mov     [Dty],eax
                mov     ax,[bx+4]
                mov     [NbRep],ax

@@Encore:       mov     ax,[Teta]
                inc     ax
                inc     ax
                mov     bx,360
                cmp     ax,bx
                jb      @@Mod360_1
                sub     ax,bx
@@Mod360_1:     mov     [Teta],ax
                sub     cl,5
                jnc     @@AvanceMoveJ           ; synchro timer
                call    TestKeys
                jz      @@MoveJulia
                jc      @@Quitte4Ko

;*** land ***
@@InitLand:     call    InitLand
                call    BuildLand
                xor     ax,ax
                mov     [Cmpt],ax
                mov     [HSec],ax
                call    AffichAndWait
                mov     [TetaRets],cl           ; sauver nb retours             - save nb vbls
@@Land:         call    AffichAndWait
                mov     cl,[TetaRets]
@@AvanceLand:   mov     ax,[Teta]
                inc     ax
                inc     ax
                mov     bx,360
                cmp     ax,bx
                jb      @@Mod360_2
                sub     ax,bx
                inc     [Cmpt]
@@Mod360_2:     mov     [Teta],ax
                mov     ax,2
                add     [CentrX],ax
                add     [CentrY],3
                cmp     [Cmpt],ax
                je      @@Goutte
                sub     cl,4
                jnc     @@AvanceLand            ; synchro timer
                call    TestKeys
                jz      @@Land
                jc      @@Quitte4Ko

;*** goutte ***
@@Goutte:       call    Defading
                call    InitGoutte
@@GouttLoop:    call    AffiChapeau
                mov     bl,3
                call    WaitAndCopy
@@AvanceGoutte: push    cx
                call    DecaleAlti
                call    CreeGoutte
                mov     ax,[Cmpt]
                add     ax,32
                cmp     ax,9000
                jb      @@NotNew
                xor     ax,ax
                inc     [CentrX]
@@NotNew:       mov     [Cmpt],ax
                cmp     [CentrX],3              ; 3 gouttes                     - 3 drops
                pop     cx
                jae     @@Defade
                sub     cl,4
                jnc     @@AvanceGoutte          ; synchro timer
                call    TestKeys
                jz      @@GouttLoop
                jc      @@Quitte4Ko

@@Defade:       call    Defading

;*** FIN ***
@@Quitte4Ko:
@@SetOldClav:   mov     bx,4
                call    SetNewInt
@@SetOldTimer:  xor     bl,bl
                xor     cx,cx
                call    SetNewInt

@@RendMem:      mov     ah,49h
                mov     es,word ptr [Ecr_Virtu+2]
                int     21h

                mov     ax,03h
                int     10h
                mov     ah,09h
                mov     dx,Offset CodeBy
                int     21h
@@MemFailed:    mov     ax,4C00h
                int     21h

IntroFli        EndP

;********************************************************************

MoveAndWait     Proc    Near

                call    MoveJulia
                mov     bl,4
                jmp    WaitAndCopy

MoveAndWait     EndP


AffichAndWait   Proc    Near

                call    AfficheLand
                mov     bl,3

AffichAndWait   EndP


WaitAndCopy     Proc    Near

                mov     dx,3DAh
@@In:           in      al,dx
                and     al,8
                jz      @@In
@@Out:          in      al,dx
                and     al,8
                jnz     @@Out
                mov     cx,[HSec]
                add     cx,8
                shr     cx,4
                cmp     cl,bl                   ; nbre retours mini             - minimal nb vbls
                jb      @@In

                mov     [HSec],0
                push    cx
                push    ds
                mov     ax,0A000h
                mov     es,ax
                xor     di,di
                lds     si,[Ecr_Virtu]
                mov     cx,320*200/4
                rep     movsd
                pop     ds
                pop     cx
                ret

WaitAndCopy     EndP


Defading        Proc    Near

                mov     cx,63
@@OneStep:      mov     di,Offset [Dac]
                mov     bx,256*3-1
@@OneByte:      cmp     byte ptr [di+bx],0
                jz      @@NextByte
                dec     byte ptr [di+bx]
@@NextByte:     dec     bx
                jnz     @@OneByte
                push    cx
                call    SetPalette
                mov     bl,1
                call    WaitAndCopy
                pop     cx
                loop    @@OneStep
                ret

Defading        EndP


TestKeys        Proc    Near

                xor     al,al
                cmp     al,[_esc]
                jc      @@Esc
                cmp     [_enter],al
                jz      @@NoKey
                mov     [_enter],al
@@Esc:
@@NoKey:        ret

TestKeys        EndP


SetMessage      Proc    Near                    ; cx = message, dx = curseur    - cx = message, dx = cursor

                call    SetPosCursor
                mov     ah,09h
                mov     dx,cx
                int     21h
                mov     dx,1900h                ; hors ecran                    - out of screen
                call    SetPosCursor
                call    MandelCopro             ; calcul 1/2 map chaque fois    - calculate 1/2 map each time
@@Wait:         cmp     [HSec],70*16*2          ; tempo 2"                      - 2" wait
                jb      @@Wait
                mov     [HSec],0
                ret

SetMessage      EndP


SetPosCursor    Proc    Near                    ; dx = coords curseur           - cursor coords

                mov     ah,02h
                xor     bh,bh
                int     10h
                ret

SetPosCursor    EndP


SetNewInt       Proc    Near                    ; bx=0: timer, bx=4: clavier    - bx=0: timer, bx=4: keyboard

                cli
                xor     ax,ax
                mov     es,ax
                mov     eax,es:[8*4+bx]
                xchg    eax,dword ptr [OffNew8+bx]
                mov     es:[8*4+bx],eax
                or      bl,bl
                jnz     @@Fin
                mov     al,36h                  ; timer frequency
                out     43h,al
                mov     al,cl
                out     40h,al
                mov     al,ch
                out     40h,al
                sti
@@Fin:          ret

SetNewInt       EndP


ReserveMem      Proc    Near

                push    ds
                pop     es
                mov     di,Offset [firstvar]
                mov     cx,Offset [lastvar]
                sub     cx,di
                xor     al,al
                rep     stosb                   ; clear all variables

                mov     ah,48h
                mov     bx,MemNeeded            ; a reserver                    - to be reserved
                int     21h
                jc      @@NotEnough
                mov     dx,ax
                mov     cx,4096
                mov     word ptr [Ecr_Virtu+2],ax
                add     ax,cx
                mov     word ptr [Map+2],ax
                add     ax,cx
                mov     word ptr [MapGoutte+2],ax
                add     ax,cx
                mov     word ptr [Randoms+2],ax
                add     ax,cx
                mov     word ptr [Carres+2],ax
                add     ax,3251
                mov     word ptr [Alti+2],ax
                add     ax,1355
                mov     word ptr [Carres2+2],ax
                add     ax,3480
                mov     word ptr [Feu+2],ax
                add     ax,2000
                mov     word ptr [SinGoutte+2],ax

                xor     ax,ax
@@ClearMem:     mov     es,dx
                mov     di,ax
                mov     cx,8
                rep     stosw                   ; clear one paragraph
                inc     dx
                dec     bx
                jnz     @@ClearMem

                mov     cs:[GermeZ],12345678h
                les     di,[Randoms]
                mov     cx,32768
@@Random:       push    1                       ; construire table randoms      - build array of randoms
                call    Randm                   ; ... pour feu                  - ... for fire
                inc     ax
                jz      @@Zero
                mov     al,100                  ; 0 ou 100
@@Zero:         stosw
                loop    @@Random

                clc
                ret

@@NotEnough:    mov     ah,09h
                mov     dx,Offset NotEnoughMem
                int     21h
                stc
                ret

ReserveMem      EndP


NewInt9         Proc    Near

                pushf
                cli
                push    ax
                push    ds
                mov     ax,@Data
                mov     ds,ax

                in      al,60h
                test    al,128
                jnz     SendAck

@@Appuie:       cmp     al,1                    ; ESC ?
                jne     @@TestEnter
                mov     [_esc],al
                jmp     SendAck
@@TestEnter:    cmp     al,28                   ; ENTER ?
                jne     SendAck
                mov     [_enter],1

SendAck:        mov     al,20h
                out     20h,al
                pop     ds
                pop     ax
                sti
                popf
                iret

NewInt9         EndP


NewInt8         Proc    Near

                pushf
                cli
                push    ax
                push    ds
                mov     ax,@Data
                mov     ds,ax
                inc     [HSec]
                jmp     SendAck

NewInt8         EndP


Randm           Proc    Near    Val : WORD
Local           hlp  : DWORD                    ; renvoie un nbre entre -Val et +Val

                pushad

                mov     ebx,127773
                mov     eax,cs:[GermeZ]
                xor     edx,edx
                div     ebx                     ; edx=z Mod 127773 et eax=z Div 127773
                mov     ecx,edx                 ; ecx=z Mod 127773
                mov     ebx,2836
                mul     ebx                     ; eax=(z Div 127773)*2836
                mov     [hlp],eax
                mov     eax,ecx                 ; eax=z Mod 127773
                mov     ebx,16807
                mul     ebx                     ; eax=16807*(z Mod 127773)
                sub     eax,[hlp]               ; eax=16807*(z Mod 127773)-2836*(z Div 127773)
                jns     @@Pas_negrm
                add     eax,2147483647
@@Pas_negrm:
                mov     cs:[germez],eax
                xor     ebx,ebx
                mov     bx,[Val]
                add     bx,bx                   ; ebx=2*no
                mul     ebx                     ; edx:eax=z*no
                mov     ebx,2147483647
                div     ebx                     ; ax=Lo(Trunc(z/2147483647*no))
                sub     ax,[Val]

                mov     word ptr [hlp],ax
                popad
                mov     ax,word ptr [hlp]
                ret

GermeZ          DD      12396                   ; 122394

Randm           EndP

;********************************************************************
; titre & feu - title & fire
;********************************************************************

InitFeu         Proc    Near

                mov     ax,13h
                int     10h

InitFeu         EndP


PaletteFeu      Proc    Near

                mov     si,Offset [Dac]
                xor     al,al                   ; i*2
                mov     ah,24                   ; 24-i*2
@@i0a7:         mov     [si+2],al
                mov     [si+24+2],ah
                add     si,3
                sub     ah,2
                add     al,2
                cmp     al,14
                jbe     @@i0a7

                xor     ax,ax                   ; (i-8)*63
                mov     cl,23
                mov     bx,3F3Fh                ; 63
@@i8a31:        mov     [si+24*3],bh
                mov     [si+48*3],bx
                push    ax
                div     cl
                mov     [si],al
                mov     [si+24*3+1],al
                mov     [si+48*3+2],al
                pop     ax
                add     si,3
                add     ax,63
                cmp     ax,23*63
                jbe     @@i8a31

SetPalette:     mov     si,Offset [Dac]
                mov     cx,256*3
                mov     dx,3C8h
                xor     al,al
                out     dx,al
                inc     dx
                rep     outsb
                ret

PaletteFeu      EndP


ProcessFlammes  Proc    Near

                push    ds
                les     di,[Ecr_Virtu]          ; depart en haut a gauche       - start top left
                lds     si,[feu]
                add     si,160*2                ; sauter une ligne              - skip 1 row
                mov     bl,98                   ; lignes                        - rows
@@0:            mov     cl,160                  ; colonnes                      - columns
@@1:
                mov     ax,[si+2]               ; calcul moyenne ponderee       - calculate weighted mean
                add     ax,ax
                add     ax,[si]
                add     ax,[si+160*2]
                shr     ax,2
                jz      @@2
                dec     ax
@@2:            mov     byte ptr [si-160*2],al  ; sauver dans tableau           - save into array
                cmp     al,79
                jbe     @@3
                mov     al,79                   ; valeur maxi palette           - max palette value
@@3:            mov     ah,al
                mov     es:[di+320],ax          ; afficher en double hauteur    - double height
                stosw                           ; ... et double largeur         - double width
                inc     si
                inc     si
                dec     cl
                jnz     @@1
                add     di,320*2-320
                dec     bl
                jnz     @@0

                pop     ds
                ret

ProcessFlammes  EndP


TraceLinesFeu   Proc    Near

                mov     fs,word ptr [Randoms+2]
                mov     bp,[RandPos]
                mov     si,Offset [Lines]
                xor     bx,bx                   ; bl=(segm-1)*8
                cmp     [ATracer],1
                jb      @@Fin

@@Forsegm:      les     di,[Feu]
                mov     dx,[si+bx]              ; Lines [segm,0].x = dx
                mov     cx,[si+bx+4]            ; Lines [segm,1].x = fx
                mov     ax,[si+bx+2]            ; Lines [segm,0].y = dy
                cmp     cx,dx
                je      @@Verticale
                jnl     @@dxInf
                xchg    cx,dx                   ; dx=i
@@dxInf:        add     di,dx
                add     di,dx
                mov     word ptr cs:[@@AddDi],0 ; automodif
                jmp     @@Suite
@@Verticale:    add     di,cx
                add     di,cx
                mov     dx,ax
                mov     cx,[si+bx+6]            ; Lines [segm,1].y = fy
                cmp     cx,dx
                jnl     @@dyInf
                xchg    cx,dx
@@dyInf:        mov     ax,dx
                mov     word ptr cs:[@@AddDi],160*2-2   ; automodif
                jmp     @@Suite
@@Suite:        shl     ax,6
                add     di,ax
                shl     ax,2
                add     di,ax
@@Forij:        mov     ax,fs:[bp]
                inc     bp
                inc     bp
                stosw
                add     di,160*2-2
@@AddDi = $-2
                inc     dx
                cmp     dx,cx
                jle     @@Forij

@@Nextsegm:     shr     bl,3                    ; segm-1
                inc     bl
                cmp     bl,[ATracer]
                je      @@Fin
                shl     bl,3
                jmp     @@Forsegm

@@Fin:          mov     [RandPos],bp
                ret

TraceLinesFeu   EndP


BuildLines      Proc    Near

                mov     di,Offset [Dir]
                mov     si,Offset [Lines]
                cmp     [Start],1
                jne     @@NoStart

                mov     [Start],0
                inc     [ATracer]
                mov     al,[ATracer]
                mov     [segg],al
                mov     [segd],al
                dec     al
                shl     al,3
                xor     ah,ah
                add     si,ax                   ; Lines [ATracer,0].x
                xor     bh,bh
                mov     bl,[Lettre]
                dec     bl
                shl     bl,2
                mov     eax,dword ptr [CaseBuildLines+bx]
                mov     dword ptr [ptd],eax
                xor     ah,ah
                mov     [si],ax

@@EndCase:      mov     al,[ptg]
                inc     al
                mov     [ptd],al
                xor     ax,ax
                mov     [di+2],ax               ; Dir [0].y=0
                mov     [di+6],ax               ; Dir [1].y=0
                dec     ax
                mov     [di],ax                 ; Dir [0].x=-1
                neg     ax
                mov     [di+4],ax               ; Dir [1].x=1
                mov     ax,[si]
                mov     [si+4],ax               ; Lines [ATracer,1].x
                mov     ax,30
                mov     [si+2],ax               ; Lines [ATracer,0].y
                mov     [si+6],ax               ; Lines [ATracer,1].y
                jmp     @@Fin

@@NoStart:      mov     bl,[segg]
                xor     bh,bh
                dec     bl
                shl     bl,3
                mov     ax,[di]                 ; Dir [0].x
                add     [si+bx],ax              ; Lines [segg,0].x
                mov     ax,[di+2]               ; Dir [0].y
                add     [si+bx+2],ax            ; Lines [segg,0].y
                mov     bl,[segd]
                dec     bl
                shl     bl,3
                mov     ax,[di+4]               ; Dir [1].x
                add     [si+bx+4],ax            ; Lines [segd,1].x
                mov     ax,[di+6]               ; Dir [1].y
                add     [si+bx+6],ax            ; Lines [segd,1].y

                push    Offset [ptg]
                push    Offset [segg]
                push    0
                call    CrossTest
                mov     ah,al                   ; Fing
                push    Offset [ptd]
                push    Offset [segd]
                push    1
                call    CrossTest
                and     al,ah                   ; Fin=Fing And Find
                mov     [FinLett],al

@@Fin:          ret

BuildLines      EndP


CrossTest       Proc    Near    pt : WORD, sg : WORD, d : BYTE
Local           Ct    : BYTE , pt0 : BYTE

                push    ax
                mov     [Ct],0                  ; false
                mov     di,word ptr [pt]
                mov     al,[di]                 ; al=pt
                mov     [pt0],al
                mov     di,Offset [Fli]
                add     al,al
                xor     ah,ah
                add     di,ax                   ; F [pt,0]
                mov     si,word ptr [sg]
                mov     al,[si]                 ; al=sg
                dec     al
                mov     si,Offset [Lines]
                shl     al,3
                add     si,ax                   ; Lines [sg,0].x
                mov     al,[d]
                shl     al,2
                add     si,ax
                mov     cl,[si]                 ; Lines [sg,d].x
                cmp     cl,[di]                 ; F [pt,0]
                jne     @@Fin
                mov     ch,[si+2]               ; Lines [sg,d].y
                cmp     ch,[di+1]               ; F [pt,1]
                jne     @@Fin

                mov     di,Offset [Dir]
                add     di,ax                   ; Dir [d].x
                xor     eax,eax
                mov     [di],eax                ; [di] et [di+2]
                mov     al,[pt0]
                mov     ah,[d]
                or      ah,ah
                jne     @@Or
                cmp     al,[limg]
                jna     @@EndIfElse
@@Or:           cmp     al,[limd]
                jnb     @@EndIfElse

                dec     al
                or      ah,ah
                jz      @@PtOk
                add     al,2
@@PtOk:         push    di
                mov     di,word ptr [pt]
                mov     [di],al                 ; modif Var pt
                mov     di,Offset [Fli]
                add     al,al
                xor     ah,ah
                add     di,ax
                mov     dl,[di]                 ; F [pt,0]
                mov     dh,[di+1]               ; F [pt,1]
                pop     di                      ; Dir [d].x
                mov     ax,1
                mov     bx,-1
                cmp     dl,cl
                jng     @@Test2
                mov     word ptr [di],ax
@@Test2:        jnl     @@Test3
                mov     word ptr [di],bx
@@Test3:        cmp     dh,ch
                jng     @@Test4
                mov     word ptr [di+2],ax
@@Test4:        jnl     @@TestOk
                mov     word ptr [di+2],bx

@@TestOk:       inc     [ATracer]
                mov     al,[Atracer]
                mov     di,word ptr [sg]
                mov     [di],al                 ; modif Var sg
                dec     al
                shl     al,3
                mov     di,Offset [Lines]
                add     di,ax
                mov     ax,[si]                 ; Lines [sg,d].x
                mov     [di],ax                 ; Lines [ATracer,0].x
                mov     [di+4],ax               ; Lines [ATracer,1].x
                mov     ax,[si+2]               ; Lines [sg,d].y
                mov     [di+2],ax               ; Lines [ATracer,0].y
                mov     [di+6],ax               ; Lines [ATracer,1].y
                jmp     @@Fin

@@EndIfElse:    mov     [Ct],1

@@Fin:          pop     ax
                mov     al,[Ct]
                ret

CrossTest       EndP


MoveBoule       Proc    Near

                mov     fs,word ptr [Randoms+2]
                mov     bp,[RandPos]
                cmp     [BouleY],100*256
                jb      @@Move
                cmp     [FinLett],0
                jz      @@Exit
                inc     [Boule]
                mov     [BouleX],60*256
                mov     [BouleY],98*256
                mov     [DeplY],-800
                mov     al,[Boule]
                cmp     al,5
                jna     @@Case
                cmp     al,17
                jnb     @@Case
                mov     [DeplY],-100
@@Case:         dec     al
                cmp     al,2
                ja      @@Exit
                xor     bh,bh
                mov     bl,al
                add     bl,bl
                mov     ax,[CaseMoveBoule+bx]
                mov     [DeplX],ax
                jmp     @@Exit

@@Move:         cmp     [Boule],3
                ja      @@Inc
                les     di,[Feu]
                mov     ax,[BouleY]
                cmp     ax,96*256
                jnb     @@NotAff
                shr     ax,8
                shl     ax,6
                add     di,ax
                shl     ax,2
                add     di,ax                   ; Feu^[j,0]
                mov     ax,[BouleX]
                cmp     ax,158*256
                jnb     @@NotAff
                shr     ax,8
                add     ax,ax
                add     di,ax                   ; Feu^[j,i]
                mov     ch,3                    ; j
@@Forj:         mov     cl,3                    ; i
@@Fori:         mov     ax,fs:[bp]
                inc     bp
                inc     bp
                stosw
                dec     cl
                jnz     @@Fori
                add     di,320-6
                dec     ch
                jnz     @@Forj

@@NotAff:       cmp     [BouleY],30*256
                jna     @@Inc
                xor     ax,ax
                cmp     [DeplY],ax
                jng     @@Inc
                inc     al
                cmp     [FinLett],al
                jne     @@Inc
                mov     [FinLett],ah
                mov     [Start],al
                inc     [Lettre]
@@Inc:          mov     ax,[DeplX]
                add     [BouleX],ax
                mov     ax,[DeplY]
                add     [BouleY],ax
                add     [DeplY],15

@@Exit:         mov     [RandPos],bp
                ret

MoveBoule       EndP

;********************************************************************
; dezoom Mandelbrot - Mandelbrot zoom out
;********************************************************************

BuildSqrMandel  Proc    Near

                mov     es,word ptr [Carres+2]
                mov     di,NbSqr*4              ; es:di sur Carres^[0]
                xor     eax,eax
                stosd
                mov     edx,eax
                inc     edx                     ; 1
                mov     bx,-8
                mov     cx,NbSqr

@@LoopSq:       add     eax,edx                 ; carre suivant                 - next square
                add     edx,2
                mov     es:[di+bx],eax
                stosd
                sub     bx,8
                loop    @@LoopSq
                ret

BuildSqrMandel  EndP


Mand_Julia      Proc    Near

                mov     eax,[Pas]               ; inits communes                - common inits
                mov     edx,eax
                imul    edx,-100
                add     ax,ax
                mov     word ptr [@@IncPtx],ax
                mov     word ptr [@@IncPty],ax
                shr     ax,1
                imul    eax,-160
                mov     ebx,eax
                les     di,[Ecr_Virtu]
                push    ds
                push    bp
                mov     bp,di
                jmp     @@Mandel1               ; automodif pour sauter aux inits
Jmp1 = $-1

@@Julia1:       mov     eax,[pty]
                mov     dword ptr [@@AddPty],eax
                mov     eax,[ptx]
                mov     dword ptr [@@AddPtx],eax
                add     bp,320*198+319          ; symetrie centrale             - central symmetry
                jmp     @@InitsOk

@@Mandel1:      mov     dword ptr [@@AddPty],edx
                add     ebx,-14000
                add     bp,320*198              ; symetrie horizontale          - horizontal symmetry

@@InitsOk:      push    ds
                pop     fs
                lds     si,[Carres]
                mov     dword ptr [@@MovPtx],ebx
                xor     al,al                   ; y=0
                jmp     @@Forj                  ; vider cache                   - clear cache

@@Forj:         and     eax,0000FFFFh           ; x=0
                mov     ecx,12345678h           ; zx depart                     - zx start
@@MovPtx = $-4
                jmp     Mandel2
Jmp2 = $-1

Mandel2:        mov     dword ptr [@@AddPtx],ecx

Julia2:
@@Fori:         push    ecx
                push    edx
                jmp     Mandel3
Jmp3 = $-1

Mandel3:        xor     ah,ah                   ; ax=y
                cmp     ax,fs:[Yh]
                jl      @@CalculMand
                cmp     ax,fs:[Yb]
                jg      @@CalculMand
                mov     ebx,eax
                shr     ebx,16                  ; bx=x
                cmp     bx,fs:[Xg]
                jl      @@CalculMand
                cmp     bx,fs:[Xd]
                jng     @@FinRepeat

@@CalculMand:   xor     ecx,ecx
                mov     edx,ecx
                mov     ebx,ecx
                mov     esi,ecx
                jmp     @@Ink

Julia3:         sar     ecx,8
                mov     ebx,[ecx*4+NbSqr*4]     ; x2
                sar     edx,8
                mov     esi,[edx*4+NbSqr*4]     ; y2
                add     ebx,esi                 ; x2+y2

@@Ink:          xor     ah,ah

@@Repeat:       add     ah,8
                cmp     ah,22*8
                jz      @@FinRepeat
                add     edx,ecx                 ; zy+zx
                mov     edx,[edx*4+NbSqr*4]     ; (zx+zy)^2
                sub     edx,ebx                 ; -(zx^2+zy^2)=>2*zx*zy
                add     edx,12345678h           ; automodif pty
@@AddPty = $-4
                sar     edx,8
                sub     ebx,esi                 ; x2
                mov     ecx,ebx
                sub     ecx,esi                 ; x2-y2
                add     ecx,12345678h           ; automodif ptx
@@AddPtx = $-4                                  ; zx=x2-y2+cx
                sar     ecx,8
                mov     esi,[edx*4+NbSqr*4]     ; edx^2
                mov     ebx,[ecx*4+NbSqr*4]     ; ecx^2
                add     ebx,esi
                cmp     ebx,1024*1024           ; sort du cercle ?              - exits the circle ?
                jl      @@Repeat

@@FinRepeat:    cmp     ah,11*8
                jb      @@FinRep2
                add     ah,9*8
@@FinRep2:      mov     es:[bp],ah
                mov     es:[bp+320],ah
                inc     bp
Inc1 = $-1
                mov     es:[bp],ah
                mov     es:[bp+320],ah
                inc     bp
Inc2 = $-1
                mov     es:[di],ah
                mov     es:[di+320],ah
                inc     di
                mov     es:[di],ah
                mov     es:[di+320],ah
                inc     di

                pop     edx                     ; recup compteurs               - get back counters
                pop     ecx
                add     ecx,00005678h
@@IncPtx = $-4
                jmp     Mandel4
Jmp4 = $-1

Mandel4:        mov     ecx,dword ptr [@@IncPtx]
                add     dword ptr [@@AddPtx],ecx

Julia4:         add     eax,00020000h
                cmp     eax,01400000h
                jb      @@Fori
                add     di,320
                sub     bp,320
                add     edx,00005678h
@@IncPty = $-4
                jmp     Mandel5
Jmp5 = $-1

Mandel5:        mov     edx,dword ptr [@@IncPty]
                add     dword ptr [@@AddPty],edx
                sub     bp,320*2

Julia5:         add     al,2
                cmp     al,100
                jnz     @@forj

                pop     bp
                pop     ds
                ret

Mand_Julia      EndP

;********************************************************************
; Julia
;********************************************************************

InitJulia       Proc    Near

                mov     al,4Dh                  ; dec bp
                mov     byte ptr [Inc1],al      ; ... dans Mandel_Julia
                mov     byte ptr [Inc2],al
                mov     al,Julia2-Mandel2
                mov     byte ptr [Jmp2],al
                mov     al,Julia3-Mandel3
                mov     byte ptr [Jmp3],al
                mov     al,Julia4-Mandel4
                mov     byte ptr [Jmp4],al
                mov     al,Julia5-Mandel5
                mov     byte ptr [Jmp5],al
                mov     byte ptr [Jmp1],0
                mov     [Pas],178
                ret

InitJulia       EndP


MoveJulia       Proc    Near                    ; fonction: true => fin trajectoire - end of path
Local           tmp  :  WORD

                call    Mand_Julia              ; construire Julia              - build Julia
                les     di,[Map]
                add     di,78*256+64
                push    ds
                lds     si,[Ecr_Virtu]
                add     si,32
                mov     bx,100

@@Copy:         mov     cx,128                  ; recopier dans Map 1 pt sur 2  - copy 1 of 2 pts in Map
@@Copy2:        movsb
                inc     si
                dec     cx
                jnz     @@Copy2
                add     si,320-256+320
                add     di,128
                dec     bx
                jnz     @@Copy
                pop     ds

                call    AfficheLand             ; construire 3D (par dessus)    - build 3D (above)
                ret

MoveJulia       EndP

;********************************************************************
; landscape
;********************************************************************

InitLand        Proc    Near

                les     di,[Map]
                xor     ax,ax
                mov     cx,65536/2
                rep     stosw
                mov     [Teta],ax

                call    BuildTrigoLand

InitLand        EndP


PaletteLand     Proc    Near

                push    ds
                pop     es
                mov     di,Offset [Dac]
                add     di,3

                xor     ax,ax
                stosw
                mov     al,63                   ; eau                 - water
                stosb

@@Verts:        mov     al,ah
                stosb
                shr     al,1
                add     al,32
                stosb
                mov     al,ah
                stosb
                add     ah,2
                cmp     ah,63
                jb      @@Verts
                jmp     SetPalette

PaletteLand     EndP


BuildLand       Proc    Near

                mov     cs:[GermeZ],36041971h
                xor     ax,ax
                push    ax
                push    ax
                mov     ax,256
                push    ax
                push    ax
                call    BuildMapLand

                mov     al,NoTestsLand-TestsLand
                mov     byte ptr [JmpLand],al
                ret

BuildLand       EndP


BuildTrigoLand  Proc    Near                    ; 256*Sin - 256*Cos - 360 degrees
Local           Loader : WORD

                mov     si,Offset [SinCos]
                mov     cx,360
                mov     [Loader],256
                fild    [Loader]
                mov     [Loader],180
                fldpi
                fidiv   [Loader]                ; pas=pi/180                    - step=pi/180
                fldz                            ; angle=0

@@BuildTLand:   fst     st(3)                   ; sauver angle                  - save angle
                fsincos
                fmul    st,st(3)                ; *256
                fistp   word ptr [si+2]
                fmul    st,st(2)                ; *256
                fistp   word ptr [si]
                add     si,4
                fld     st(2)                   ; recuperer angle               - get back angle
                fadd    st,st(1)                ; + pas
                loop    @@BuildTLand

;                fstp
;                fstp
;                fstp
;                fstp
                ret

BuildTrigoLand  EndP


BuildMapLand    Proc    Near    x1 : WORD, y1 : WORD, x2 : WORD, y2 : WORD
Local           p1, p2, p3, p4, xn, yn : WORD

                pusha
                mov     ax,[y1]
                mov     bx,[x1]
                mov     cx,[y2]
                mov     dx,[x2]
                sub     dx,bx                   ; x2-x1
                sub     cx,ax                   ; y2-y1
                cmp     dx,2
                jnl     @@Sup2
                cmp     cx,2
                jl      @@Quitte

@@Sup2:         mov     bh,al
                mov     ds,word ptr [Map+2]
                xor     ah,ah
                mov     al,[bx]
                mov     [p1],ax                 ; Map^[y1 Shl 8+x1]
                mov     bh,byte ptr [y2]
                mov     al,[bx]
                mov     [p2],ax                 ; Map^[y2 Shl 8+x1]
                mov     bx,[x2]
                add     bh,byte ptr [y1]
                mov     al,[bx]
                mov     [p3],ax                 ; Map^[y1 Shl 8+x2]
                mov     bx,[x2]
                add     bh,byte ptr [y2]
                mov     al,[bx]
                mov     [p4],ax                 ; Map^[y2 Shl 8+x2]

                mov     ax,[x2]
                add     ax,[x1]
                shr     ax,1
                mov     [xn],ax
                mov     ax,[y2]
                add     ax,[y1]
                shr     ax,1
                mov     [yn],ax
                mov     ax,cx
                add     ax,dx                   ; x2-x1+y2-y1
                mov     cx,ax
                shl     ax,2
                add     ax,cx                   ; *5
                xor     dx,dx
                mov     cx,3
                idiv    cx                      ; /3
                mov     cx,ax                   ; dxy
                mov     si,2                    ; dvd

                mov     bx,[xn]
                mov     bh,byte ptr [y1]
                cmp     byte ptr [bx],0         ; Map^[y1 Shl 8+xn]
                jne     @@Test2
                mov     ax,[p1]
                add     ax,[p3]
                call    NCol
                mov     [bx],al
@@Test2:        mov     bx,[x1]
                mov     bh,byte ptr [yn]
                cmp     byte ptr [bx],0         ; Map^[yn Shl 8+x1]
                jne     @@Test3
                mov     ax,[p1]
                add     ax,[p2]
                call    NCol
                mov     [bx],al
@@Test3:        mov     bx,[x2]
                add     bh,byte ptr [yn]
                cmp     byte ptr [bx],0         ; Map^[yn Shl 8+x2]
                jne     @@Test4
                mov     ax,[p3]
                add     ax,[p4]
                call    NCol
                mov     [bx],al
@@Test4:        mov     bx,[xn]
                mov     bh,byte ptr [y2]
                cmp     byte ptr [bx],0         ; Map^[y2 Shl 8+xn]
                jne     @@YnXn
                mov     ax,[p2]
                add     ax,[p4]
                call    NCol
                mov     [bx],al
@@YnXn:         mov     ax,[p1]
                add     ax,[p2]
                add     ax,[p3]
                add     ax,[p4]
                add     si,si
                call    NCol
                mov     bx,[xn]
                mov     bh,byte ptr [yn]
                mov     [bx],al                 ; Map^[yn Shl 8+xn]

                mov     ax,@Data
                mov     ds,ax
                mov     ax,[x1]
                mov     bx,[y1]
                mov     cx,[x2]
                mov     dx,[y2]
                mov     di,[xn]
                mov     si,[yn]
                push    ax                      ; x1
                push    bx                      ; y1
                push    di                      ; xn
                push    si                      ; yn
                call    BuildMapLand
                push    di                      ; xn
                push    bx                      ; y1
                push    cx                      ; x2
                push    si                      ; yn
                call    BuildMapLand
                push    ax                      ; x1
                push    si                      ; yn
                push    di                      ; xn
                push    dx                      ; y2
                call    BuildMapLand
                push    di                      ; xn
                push    si                      ; yn
                push    cx                      ; x2
                push    dx                      ; y2
                call    BuildMapLand

@@Quitte:       popa
                ret

BuildMapLand    EndP


NCol            Proc    Near                    ; ax=mc, cx=n, si=dvd

                mov     di,ax                   ; mc
                push    cx                      ; n
                call    Randm                   ; [-n;+n]
                add     ax,di                   ; +mc
                cwd
                idiv    si                      ; /dvd
                cmp     ax,255
                jng     @@UpOk
                mov     ax,255
@@UpOk:         cmp     ax,8
                jnl     @@DownOk
                mov     ax,8
@@DownOk:       ret

NCol            EndP


AfficheLand     Proc    Near
Local           steta : DWORD, cteta : DWORD
Local           x1    : DWORD, y1    : DWORD
Local           x0    : DWORD, y0    : DWORD

                push    ds
                pop     es
                mov     di,Offset [Horiz]
                mov     ax,0C8C8h               ; 200
                mov     cx,160/2
                rep     stosw                   ; horizon bas

                mov     bx,[Teta]
                shl     bx,2
                add     bx,Offset [SinCos]
                mov     ax,[bx]                 ; steta
                cwde
                mov     [steta],eax
                imul    eax,-80
                mov     cx,[CentrY]
                shl     cx,8
                movzx   ecx,cx
                add     ecx,eax
                mov     ax,[bx+2]               ; cteta
                cwde
                mov     [cteta],eax
                imul    eax,-100
                add     eax,ecx
                mov     [y1],eax                ; y1=-80*steta-100*cteta+CentrY*256
                mov     cx,[CentrX]
                shl     cx,8
                movzx   ecx,cx
                mov     eax,[cteta]
                imul    eax,80
                add     ecx,eax
                mov     eax,[steta]
                imul    eax,-100
                add     eax,ecx
                mov     [x1],eax                 ; x1=80*cteta-100*steta+CentrX*256

                mov     si,di
                dec     si                      ; Horiz [159]
                mov     es,word ptr [Ecr_Virtu+2]
                mov     fs,word ptr [Map+2]
                mov     ch,199+32+1             ; ch=j+1

@@Forj:         mov     edx,[x1]                ; dx=x0
                mov     ebx,[y1]                ; bx=y0
                mov     eax,[steta]
                add     [x1],eax
                mov     eax,[cteta]
                add     [y1],eax
                mov     cl,159+1                ; cl=i+1
                mov     di,320-2

@@Fori:         cmp     byte ptr [si],0
                jna     @@Next
                jmp     TestsLand
JmpLand = $-1
TestsLand:      cmp ebx,178*256-1               ; y bas
                ja  @@Next2
                cmp ebx,78*256                  ; y haut
                jb  @@Next2
                cmp edx,192*256-1               ; x droit
                ja  @@Next2
                cmp edx,64*256                  ; x gauche
                jb  @@Next2
NoTestsLand:
                mov     ah,bl
                mov     bl,dh                   ; bh=Hi(y0); bl=Hi(x0)
                mov     al,fs:[bx]
                shr     al,3                    ; z
                mov     bl,ah
                mov     ah,ch
                dec     ah
                sub     ah,al                   ; j-z
                jnc     @@AbsOk                 ; >=0
                xor     ah,ah
@@AbsOk:        cmp     ah,[si]                 ; j-z < Horiz[i] ?
                jnb     @@Next
                xchg    ah,[si]                 ; ah=Horiz[i]
                push    bx
                mov     bh,ah
                dec     bh
                xor     bl,bl                   ; bx=(Horiz[i]-1)*256
                push    di
                add     di,bx
                shr     bx,2
                add     di,bx
                mov     bl,ah
                sub     bl,[si]                 ; compteur                      - counter
                mov     ah,al
@@Fork:         mov     es:[di],ax
                sub     di,320
                dec     bl
                jnz     @@Fork
                pop     di
                pop     bx
@@Next:         sub     di,2
                dec     si
                sub     edx,[cteta]
                add     ebx,[steta]
                dec     cl
                jnz     @@Fori
                add     si,160
                dec     ch
                jnz     @@Forj
                ret

@@Next2:        mov     ah,ch
                sub     ah,2                    ; j-z avec z=1
                jnc     @@AbsOk2                ; >=0
                xor     ah,ah
@@AbsOk2:       cmp     ah,[si]                 ; j-z < Horiz[i] ?
                jnb     @@Next
                mov     [si],ah
                jmp     @@Next

AfficheLand     EndP

;********************************************************************
; Mandel Copro (map goutte - drop's map)
;********************************************************************

MandelCopro     Proc    Near

                mov     ch,128                  ; 128 lignes                    - 128 rows
@@Forj:         xor     cl,cl                   ; 256 colonnes                  - 256 columns
                mov     [LdW2],-23593-100       ; colonne 0 (160)

@@Fori:         fild    [LdW1]                  ; ST=lig 0
                fidiv   [LdW3]                  ; ST=lig/32768
                fild    [LdW2]                  ; ST=col 0
                fidiv   [LdW3]                  ; ST(1)=lig/32768; ST=col/32768
                fldz                            ; empiler 0=(x+y)^2             - push 0
                fldz                            ; x^2-y^2
                fldz                            ; x^2+y^2
                mov     bl,63                   ; iterations                    - loops
@@Iter:         fsubr   st,st(2)                ; st=2.x.y
                fadd    st,st(4)                ; +cy => zy
                fld     st(1)                   ; empiler x^2-y^2               - push x^2-y^2
                fadd    st,st(4)                ; +cx => zx
                fld     st(0)                   ; empiler zx                    - push zx
                fadd    st,st(2)                ; +zy
                fmul    st,st                   ; (zx+zy)^2
                fstp    st(4)                   ; ecraser ancienne valeur et depiler - replace old value and pop
                fmul    st,st                   ; zx^2
                fst     st(2)                   ; a la place de x^2-y^2         - replace x^2-y^2
                fld     st(1)                   ; empiler zy                    - push zy
                fmul    st,st                   ; zy^2
                fsub    st(3),st                ; nouveau x^2-y^2               - new x^2-y^2
                faddp   st(1)                   ; zx^2+zy^2
                fstp    st(1)                   ; ecraser ancienne valeur et depiler - replace old value and pop
                fild    [LdW4]                  ; max module
                fcomp
                fstsw   ax                      ; transferer les flags          - get copro flags
                sahf
                jb      @@FinRep                ; module depasse                - out of range
                dec     bl
                jz      @@FinRep                ; iterations maxi
                jmp     @@Iter

@@FinRep:       mov     al,bl
                inc     al
                stosb
                fstp
                fstp
                fstp
                fstp
                fstp                            ; depiler 5 registres           - pop 5 registers
                inc     [LdW2]
                dec     cl
                jnz     @@Fori
                inc     [LdW1]
                dec     ch
                jnz     @@Forj
                ret

MandelCopro     EndP

;********************************************************************
; goutte mappee - textured drop
;********************************************************************

InitGoutte      Proc    Near

                call    BuildSqrGoutte
                call    BuildSqrtGoutte
                call    BuildSinGoutte
                xor     ax,ax
                mov     [Cmpt],ax
                mov     [CentrX],ax

InitGoutte      EndP


PaletteGoutte   Proc    Near

                push    ds
                pop     es
                mov     di,Offset [Dac]
                push    di
                xor     ax,ax
                mov     cx,256*3/2
                rep     stosw
                pop     di
                add     di,3

                mov     al,3Fh
@@bleus:        mov     [di+2],al
                mov     [di+21*3+1],al
                mov     [di+42*3],al
                add     di,3
                sub     al,3
                jnz     @@bleus
                call    AffiChapeau
                mov     bl,1
                call    WaitAndCopy
                jmp     SetPalette

PaletteGoutte   EndP


BuildSqrGoutte  Proc    Near

                les     di,[Carres2]
                mov     ebx,254-175-1           ; j initial
                mov     esi,160*160*2

@@BSqrj:        mov     ecx,160                 ; abs(xp)
                inc     bx
@@BSqrxp:       mov     eax,ecx
                mul     ebx
                shr     eax,1
                mul     eax
                div     esi
                stosw
                loop    @@BSqrxp
                inc     bx
                cmp     bx,254                  ; j=0 ?
                jbe     @@BSqrNeg
                inc     bx
@@BSqrNeg:      cmp     bx,254+255
                jbe     @@BSqrj
                ret

BuildSqrGoutte  EndP


BuildSqrtGoutte Proc    Near
Local           N     : DWORD
Local           Result : WORD

                les     di,[Alti]
                add     di,AltiSize*2           ; Raci
                mov     cx,RaciSize
                mov     [N],0                   ; 1er carre                     - 1st square
@@BuilSqrt:     fild    [N]
                fsqrt
                fistp   [Result]
                mov     ax,[Result]
                stosw
                add     [N],163*163             ; carre suivant                 - next square
                loop    @@BuilSqrt
                ret

BuildSqrtGoutte EndP


BuildSinGoutte  Proc    Near
Local           i,j,Cst,Trois,Result : WORD

                les     di,[SinGoutte]
                cld
                mov     [Cst],163
                mov     [Trois],3
                mov     [i],0                   ; i
                mov     [j],4608*2              ; (4608-i)*2

@@Calcul:       fild    i
                fidiv   [Cst]                   ; i/163
                fsin                            ; Sin(i/163)
                fimul   [j]
                fidiv   [Trois]
                fistp   [Result]
                mov     ax,[Result]
                neg     ax
                stosw
                inc     [i]
                sub     [j],2
                cmp     [i],4096
                jb      @@Calcul
                ret

BuildSinGoutte  EndP


AffiChapeau     Proc    Near
Local           j, j2, k, OffHaut : WORD

                lgs     ax,[MapGoutte]
                lfs     si,[Carres2]
                les     di,[Alti]
                add     di,2*AltiSize+2*RaciSize
                mov     [OffHaut],di            ; Haut
                mov     cx,160/2
                mov     ax,0c8c8h               ; 200
                rep     stosw                   ; initialiser horizon flottant  - initialize floating horizon
                les     ax,[Ecr_Virtu]
                push    ds
                lds     ax,[Alti]

                mov     [k],-175+254
                mov     [j],-175                ; j=-175 a 255
                mov     ax,[j]

@@forj:         imul    ax                      ; ax=j*j
                shr     ax,3
                mov     [j2],ax                 ; j2=j^2/8
                xor     bx,bx                   ; bx=xp=0  159

@@forxp:        mov     di,fs:[si]              ; di=Carres^[cmp,xp]
                add     di,[j2]
                shr     di,4                    ; (i^2+j^2)/128
                add     di,di
                add     di,AltiSize*2
                mov     di,[di]                 ; di=SqD
                add     di,di
                mov     cx,[di]                 ; cx=z
                mov     ax,64*256
                sub     ax,cx                   ; ax=64*256-z
                xor     dx,dx
                mov     di,[k]
                div     di                      ; ax=yp=(64*256-z) Div k

                cmp     al,200-18               ; pour descendre a l'ecran      - to go down on the screen
                jae     @@dejapt
                add     al,18

                mov     di,[OffHaut]            ; Haut
                mov     dl,[di+bx]              ; dl=Haut [xp]
                cmp     al,dl                   ; yp < Haut [xp] ?
                jae     @@dejapt

                mov     [di+bx],al              ; Haut [xp]=yp
                sub     dl,al                   ; nbre de lignes a remplir      - nb rows to fill
                mov     di,ax
                shl     ax,8
                shl     di,6
                add     di,ax                   ; di=320*yp

                sar     cx,7                    ; z/128
                jns     @@zposi
                neg     cl
@@zposi:        add     cl,15
                mov     ch,cl

                mov     ax,bx
                mov     bx,[k]
                shr     bx,1
                mov     bh,bl
                mov     bl,al
                shr     bl,1                    ; bx=256*(k/2)+(xp/2)
                mov     ch,gs:[bx]              ; map
                neg     bl
                add     bl,160
                mov     cl,gs:[bx]
                mov     bx,ax

                sub     di,bx
                add     bx,bx
@@forl:         mov     es:[di+bx],ch           ; afficher                      - plot
                mov     es:[di+319],cl          ; symetrique
                add     di,320
                dec     dl
                jnz     @@forl
                shr     bx,1

@@dejapt:       inc     bx                      ; xp+1
                add     si,2
                cmp     bx,160
                jb      @@forxp

                mov     ax,[j]
                add     [k],2
                add     ax,2
                js      @@jnegatif
                inc     ax
                inc     [k]
@@jnegatif:     mov     [j],ax
                cmp     ax,257
                jne     @@forj
                pop     ds

                xor     di,di
                mov     eax,0F0F0F0Fh
                mov     cx,50*320/4
                rep     stosd                   ; effacer 50 lignes             - clear 50 rows
                ret

AffiChapeau     EndP


DecaleAlti      Proc    Near

                push    ds
                les     di,[Alti]
                lds     si,[Alti]
                add     di,(AltiSize-1)*2
                add     si,(AltiSize-1-32)*2
                std
                mov     cx,AltiSize-1-31
                rep     movsw
                cld
                pop     ds
                ret

DecaleAlti      EndP


CreeGoutte      Proc    Near

                les     di,[Alti]
                add     di,31*2                 ; Alti^[31-0]
                mov     cx,32                   ; i
                lfs     si,[SinGoutte]
                mov     bx,[cmpt]
                mov     si,bx
                add     si,si                   ; Sinus^[cmpt]

@@Fori:         cmp     bx,4096
                ja      @@Zero
                mov     ax,fs:[si]
                add     si,2
                mov     es:[di],ax
                sub     di,2
                inc     bx
                loop    @@Fori
                jmp     @@Sortie

@@Zero:         xor     ax,ax
                mov     es:[di],ax
                sub     di,2
                loop    @@Zero

@@Sortie:       ret

CreeGoutte      EndP


               .STACK  2048

                END    IntroFli
