;******************************** FLI *******************************
;*                 a 4Ko intro by Real Time in 1995                 *
;*                   Windows OpenGL version in 2002                 *
;*                   http://www.fairyengine.com                     *
;********************************************************************

                .586p
                .MODEL  FLAT,STDCALL

OPTION          NOSCOPED                ; all labels are global
OPTION          CASEMAP:NONE            ; case sensitivity enabled

include         windows.inc
include         d:\masm32\include\WinExtra\winextra.def

include         d:\masm32\include\OpenGL\gl.def
include         d:\masm32\include\OpenGL\glu.def
includelib      opengl32.lib
includelib      glu32.lib

include         kernel32.inc
include         user32.inc
include         gdi32.inc
includelib      kernel32.lib
includelib      user32.lib
includelib      gdi32.lib

include         winmm.inc
includelib      winmm.lib

;********************************************************************

NbSqr           Equ     6500            ; carres pour les fractales             - squares for fractals
AltiSize        Equ     8222            ; taille tableau altitudes goutte       - size of array for drop's heights
RaciSize        Equ     2533            ; idem pour tableau racines             - same thing for square roots array
MemNeeded       Equ     4096+4096*3*4+4096+4096+4096+3251+1355+3480+2000+512 ; *16 bytes
;                       Ecr_Virtu+Ecr_Virtu2+Map+MapGoutte+Randoms+Carres+Alti+Carres2+Feu+SinGoutte


                .DATA

ALIGN DWORD                             ; EVENDATA
Pas             DD      190             ; pas de la Mandelbrot                  - Mandelbrot step
ptx             DD     -158000          ; position en x dans Julia              - x position in Julia
dtx             DD      1000            ; deplacement en x Julia                - x move for Julia

LdW1            DD      10001-100       ; ligne 0 (100) MandelCopro             - 0 (100) line MandelCopro
LdW3            DD      32768           ; diviseur MandelCopro                  - MandelCopro divisor
LdW4            DD      4               ; module max MandelCopro                - MandelCopro max value

CaseBuildLines  DB      30,4,0,10       ; [si],ptg,limg,limd
                DB      71,13,11,17
                DB      131,20,18,22

CaseMoveBoule   DW      -100,30,225     ; DeplX

TrajJulia       DW      1000,0,67,      1000,1000,25,   1000,0,18
                DW      1000,1000,35,   1000,0,10,      1000,-1000,15
                DW      1000,0,16,      0,-1000,500

BouleY          DW      100*256         ; position boule en y                   - ball's y position
Cmpt            DW      132             ; compteur                              - counter
Xg              DW      20              ; fenetre noire Mandelbrot              - Mandelbrot's black window
Xd              DW      309
Yh              DW     -20
Yb              DW      219
NbRep           DW      67              ; nombre de repetitions trajectoire     - nb path loops
CentrX          DW      128             ; position dans le land                 - position in landscape
CentrY          DW      128

FinLett         DB      1               ; lettre terminee                       - finished letter

Fli             DB      40,60,30,60,30,70,20,70,20,30                   ; F
                DB      50,30,50,40,30,40,30,50,40,50,40,60
                DB      110,70,70,70,70,30,80,30,80,60,110,60,110,70    ; L
                DB      140,70,130,70,130,30,140,30,140,70              ; I

NotEnoughMem    DB      'NOT enough memory$'
CodeBy          DB      '(c) 1995 by MYTHOS / '
RealTime        DB      'REAL  TIME$'
Presents        DB      'presents$'
WinVersion      DB      '2002 win32 OpenGL version'

MyClassName     DB      'Asm',0
WinTitleString  DB      'Fli',0


                .DATA?

ALIGN DWORD                             ; EVENDATA
firstvar        DD      ?
GermeZ          DD      ?
AddDi           DD      ?

Carres          DD      ?               ; table des carres (fractales)          - array of squares (fractals)
Carres2         DD      ?               ; table des carres (goutte)             - array of squares (drop)
Ecr_Virtu       DD      ?               ; ecran virtuel                         - virtual screen
Ecr_Virtu2      DD      ?               ; GL top-down version of Ecr_Virtu
Map             DD      ?               ; map pour le land                      - landscape's map
MapGoutte       DD      ?               ; map pour la goutte                    - drop's map
Feu             DD      ?               ; tableau 160x100 flammes               - flames' 160*x100 array
SinGoutte       DD      ?               ; 4096 sinus
Alti            DD      ?               ; pointeurs de la goutte                - drop's pointers
Randoms         DD      ?               ; table de nbres aleatoires (words)     - array of random values

pty             DD      ?               ; position en y dans Julia              - y position in Julia
dty             DD      ?               ; deplacement en y Julia                - y move for Julia
LdW2            DD      ?               ; col MandelCopro *32768

JuliaIncPtx     DD      ?               ; these vars replace the auto-modified code
JuliaIncPty     DD      ?
JuliaAddPtx     DD      ?
JuliaAddPty     DD      ?
JuliaMovPtx     DD      ?

JuliaJmp1       DD      ?
JuliaJmp2       DD      ?
JuliaJmp3       DD      ?
JuliaJmp4       DD      ?
JuliaJmp5       DD      ?
JuliaInc1       DD      ?
JuliaInc2       DD      ?

JmpTestsLand    DD      ?

; Windows & GL

hdc             HDC     ?               ; GDI device context
hrc             HGLRC   ?               ; OGL rendering context

hWindow         HWND    ?
hInstance       HANDLE  ?
Activity        DWORD   ?

hlp             DD      ?
TimeGetTime     DD      ?

;

HSec            DW      ?               ; compteur timer                        - timer counter
SinCos          DW      360*2   DUP (?) ; table de sinus et cosinus *256        - array of sines & cosines *256
Lines           DW      20*4    DUP (?) ; lettres de feu                        - fire letters
Dir             DW      4       DUP (?) ; direction du trace                    - drawing direction
DeplX           DW      ?               ; deplacement correspondant             - corresponding move
DeplY           DW      ?
BouleX          DW      ?               ; position boule en x                   - ball's x position
RandPos         DW      ?               ; index dans table randoms              - randoms array's index

Teta            DW      ?
TetaRets        DB      ?               ; nb retours Julia & land               - nb vbls Julia & landscape

PtTraj          DB      ?               ; position dans TrajJulia               - position in TrajJulia
Horiz           DB      160     DUP (?) ; horizon flottant du land              - landscape's line of sight
Dac             DB      256*3   DUP (?) ; palette                               - 
ptd             DB      ?               ; pt droit segment en cours -| dans     - right point current segment -| in
ptg             DB      ?               ; id gauche                  | cet      - left                         | this
limg            DB      ?               ; num pt gauche stop         | ordre    - left stop point number       | order
limd            DB      ?               ; id droit                  -| !!!      - right                       -| !!!
segg            DB      ?               ; num segment gauche en cours           - current left segment number
segd            DB      ?               ; id droit                              -         right
Start           DB      ?               ; boolean : commencer lettre            - boolean : start letter
ATracer         DB      ?               ; nbre segments a tracer                - nb segments to draw

Boule           DB      ?               ; nbre de boules                        - nb balls
Lettre          DB      ?               ; num lettre a tracer                   - number of letter to draw

_enter          DB      ?               ; enter  pressed
TextScreen      DB      ?

lastvar         DB      ?


                .CODE

;********************************************************************
; titre & feu - title & fire
;********************************************************************

InitFeu         Proc    Near

                lea     esi,Dac
                xor     al,al                   ; i*2
                mov     ah,24                   ; 24-i*2
@@i0a7:         mov     [esi+2],al
                mov     [esi+24+2],ah
                add     esi,3
                sub     ah,2
                add     al,2
                cmp     al,14
                jbe     @@i0a7

                xor     ax,ax                   ; (i-8)*63
                mov     cl,23
                mov     bx,3F3Fh                ; 63
@@i8a31:        mov     [esi+24*3],bh
                mov     [esi+48*3],bx
                push    ax
                div     cl
                mov     [esi],al
                mov     [esi+24*3+1],al
                mov     [esi+48*3+2],al
                pop     ax
                add     esi,3
                add     ax,63
                cmp     ax,23*63
                jbe     @@i8a31

SetPalette:     ret

InitFeu         EndP


ProcessFlammes  Proc    Near

                mov     edi,[Ecr_Virtu]         ; depart en haut a gauche       - start top left
                mov     esi,[Feu]
                add     esi,160*2               ; sauter une ligne              - skip 1 row
                mov     bl,98                   ; lignes                        - rows
@@0:            mov     cl,160                  ; colonnes                      - columns
@@1:
                mov     ax,[esi+2]              ; calcul moyenne ponderee       - calculate weighted mean
                add     ax,ax
                add     ax,[esi]
                add     ax,[esi+160*2]
                shr     ax,2
                jz      @@2
                dec     ax
@@2:            mov     [esi-160*2],al          ; sauver dans tableau           - save into array
                cmp     al,79
                jbe     @@3
                mov     al,79                   ; valeur maxi palette           - max palette value
@@3:            mov     ah,al
                mov     [edi+320],ax            ; afficher en double hauteur    - double height
                stosw                           ; ... et double largeur         - double width
                inc     esi
                inc     esi
                dec     cl
                jnz     @@1
                add     edi,320*2-320
                dec     bl
                jnz     @@0

                ret

ProcessFlammes  EndP


TraceLinesFeu   Proc    Near

                push    ebp
                mov     ebp,[Randoms]
                xor     ebx,ebx
                mov     bx,[RandPos]
                add     ebp,ebx
                lea     esi,Lines
                xor     ebx,ebx                 ; bl=(segm-1)*8
                cmp     [ATracer],1
                jb      @@Fin

@@Forsegm:      mov     edi,[Feu]
                xor     edx,edx
                xor     ecx,ecx
                xor     eax,eax
                mov     dx,[esi+ebx]            ; Lines [segm,0].x = dx
                mov     cx,[esi+ebx+4]          ; Lines [segm,1].x = fx
                mov     ax,[esi+ebx+2]          ; Lines [segm,0].y = dy
                cmp     cx,dx
                je      @@Verticale
                jnl     @@dxInf
                xchg    cx,dx                   ; dx=i
@@dxInf:        add     edi,edx
                add     edi,edx
                mov     [AddDi],0               ; automodif
                jmp     @@Suite
@@Verticale:    add     edi,ecx
                add     edi,ecx
                mov     dx,ax
                mov     cx,[esi+ebx+6]          ; Lines [segm,1].y = fy
                cmp     cx,dx
                jnl     @@dyInf
                xchg    cx,dx
@@dyInf:        mov     ax,dx
                mov     [AddDi],160*2-2         ; automodif
                jmp     @@Suite
@@Suite:        shl     ax,6
                add     edi,eax
                shl     ax,2
                add     edi,eax
@@Forij:        mov     ax,[ebp]
                inc     ebp
                inc     ebp
                stosw
                add     edi,[AddDi]
                inc     dx
                cmp     dx,cx
                jle     @@Forij

@@Nextsegm:     shr     bl,3                    ; segm-1
                inc     bl
                cmp     bl,[ATracer]
                je      @@Fin
                shl     bl,3
                jmp     @@Forsegm

@@Fin:          mov     ebx,[Randoms]
                sub     ebp,ebx
                mov     [RandPos],bp
                pop     ebp
                ret

TraceLinesFeu   EndP


BuildLines      Proc    Near

                lea     edi,Dir
                lea     esi,Lines
                cmp     [Start],1
                jne     @@NoStart

                mov     [Start],0
                inc     [ATracer]
                xor     eax,eax
                mov     al,[ATracer]
                mov     [segg],al
                mov     [segd],al
                dec     al
                shl     al,3
                add     esi,eax                 ; Lines [ATracer,0].x
                xor     ebx,ebx
                mov     bl,[Lettre]
                dec     bl
                shl     bl,2
                mov     eax,dword ptr [CaseBuildLines+ebx]
                mov     dword ptr [ptd],eax
                xor     ah,ah
                mov     [esi],ax

@@EndCase:      mov     al,[ptg]
                inc     al
                mov     [ptd],al
                xor     ax,ax
                mov     [edi+2],ax              ; Dir [0].y=0
                mov     [edi+6],ax              ; Dir [1].y=0
                dec     ax
                mov     [edi],ax                ; Dir [0].x=-1
                neg     ax
                mov     [edi+4],ax              ; Dir [1].x=1
                mov     ax,[esi]
                mov     [esi+4],ax              ; Lines [ATracer,1].x
                mov     ax,30
                mov     [esi+2],ax              ; Lines [ATracer,0].y
                mov     [esi+6],ax              ; Lines [ATracer,1].y
                jmp     @@Fin2

@@NoStart:      xor     ebx,ebx
                mov     bl,[segg]
                dec     bl
                shl     bl,3
                mov     ax,[edi]                ; Dir [0].x
                add     [esi+ebx],ax            ; Lines [segg,0].x
                mov     ax,[edi+2]              ; Dir [0].y
                add     [esi+ebx+2],ax          ; Lines [segg,0].y
                mov     bl,[segd]
                dec     bl
                shl     bl,3
                mov     ax,[edi+4]              ; Dir [1].x
                add     [esi+ebx+4],ax          ; Lines [segd,1].x
                mov     ax,[edi+6]              ; Dir [1].y
                add     [esi+ebx+6],ax          ; Lines [segd,1].y

                lea     edi,ptg
                lea     esi,segg
                push    0
                push    esi
                push    edi
                call    CrossTest
                mov     ah,al                   ; Fing
                lea     edi,ptd
                lea     esi,segd
                push    1
                push    esi
                push    edi
                call    CrossTest
                and     al,ah                   ; Fin=Fing And Find
                mov     [FinLett],al

@@Fin2:         ret

BuildLines      EndP


CrossTest       Proc    Near    pt : DWORD, sg : DWORD, d : BYTE
Local           Ct    : BYTE , pt0 : BYTE

                push    eax
                xor     eax,eax
                mov     [Ct],0                  ; false
                mov     edi,[pt]
                mov     al,[edi]                ; al=pt
                mov     [pt0],al
                lea     edi,Fli
                add     al,al
                add     edi,eax                 ; F [pt,0]
                mov     esi,[sg]
                mov     al,[esi]                ; al=sg
                dec     al
                lea     esi,Lines
                shl     al,3
                add     esi,eax                 ; Lines [sg,0].x
                mov     al,[d]
                shl     al,2
                add     esi,eax
                mov     cl,[esi]                ; Lines [sg,d].x
                cmp     cl,[edi]                ; F [pt,0]
                jne     @@Fin3
                mov     ch,[esi+2]              ; Lines [sg,d].y
                cmp     ch,[edi+1]              ; F [pt,1]
                jne     @@Fin3

                lea     edi,Dir
                add     edi,eax                 ; Dir [d].x
                xor     eax,eax
                mov     [edi],eax               ; [di] et [di+2]
                mov     al,[pt0]
                mov     ah,[d]
                or      ah,ah
                jne     @@Or
                cmp     al,[limg]
                jna     @@EndIfElse
@@Or:           cmp     al,[limd]
                jnb     @@EndIfElse

                dec     al
                or      ah,ah
                jz      @@PtOk
                add     al,2
@@PtOk:         push    edi
                mov     edi,[pt]
                mov     [edi],al                ; modif Var pt
                lea     edi,Fli
                add     al,al
                and     eax,0FFh
                add     edi,eax
                mov     dl,[edi]                ; F [pt,0]
                mov     dh,[edi+1]              ; F [pt,1]
                pop     edi                     ; Dir [d].x
                mov     eax,1
                mov     ebx,-1
                cmp     dl,cl
                jng     @@CrossTest2
                mov     word ptr [edi],ax
@@CrossTest2:   jnl     @@CrossTest3
                mov     word ptr [edi],bx
@@CrossTest3:   cmp     dh,ch
                jng     @@CrossTest4
                mov     word ptr [edi+2],ax
@@CrossTest4:   jnl     @@CrossTestOk
                mov     word ptr [edi+2],bx

@@CrossTestOk:  inc     [ATracer]
                mov     al,[ATracer]
                mov     edi,[sg]
                mov     [edi],al                ; modif Var sg
                dec     al
                shl     al,3
                lea     edi,Lines
                add     edi,eax
                mov     ax,[esi]                ; Lines [sg,d].x
                mov     [edi],ax                ; Lines [ATracer,0].x
                mov     [edi+4],ax              ; Lines [ATracer,1].x
                mov     ax,[esi+2]              ; Lines [sg,d].y
                mov     [edi+2],ax              ; Lines [ATracer,0].y
                mov     [edi+6],ax              ; Lines [ATracer,1].y
                jmp     @@Fin3

@@EndIfElse:    mov     [Ct],1

@@Fin3:         pop     eax
                mov     al,[Ct]
                ret

CrossTest       EndP


MoveBoule       Proc    Near

                push    ebp
                mov     ebp,[Randoms]
                xor     ebx,ebx
                mov     bx,[RandPos]
                add     ebp,ebx

                cmp     [BouleY],100*256
                jb      @@Move
                cmp     [FinLett],0
                jz      @@Exit
                inc     [Boule]
                mov     [BouleX],60*256
                mov     [BouleY],98*256
                mov     [DeplY],-800
                mov     al,[Boule]
                cmp     al,5
                jna     @@Case
                cmp     al,17
                jnb     @@Case
                mov     [DeplY],-100
@@Case:         dec     al
                cmp     al,2
                ja      @@Exit
                xor     ebx,ebx
                mov     bl,al
                add     bl,bl
                mov     ax,[CaseMoveBoule+ebx]
                mov     [DeplX],ax
                jmp     @@Exit

@@Move:         cmp     [Boule],3
                ja      @@Inc
                mov     edi,[Feu]
                xor     eax,eax
                mov     ax,[BouleY]
                cmp     ax,96*256
                jnb     @@NotAff
                shr     ax,8
                shl     ax,6
                add     edi,eax
                shl     ax,2
                add     edi,eax                 ; Feu^[j,0]
                mov     ax,[BouleX]
                cmp     ax,158*256
                jnb     @@NotAff
                shr     ax,8
                add     ax,ax
                add     edi,eax                 ; Feu^[j,i]
                mov     ch,3                    ; j
@@Forj:         mov     cl,3                    ; i
@@Fori:         mov     ax,[ebp]
                inc     ebp
                inc     ebp
                stosw
                dec     cl
                jnz     @@Fori
                add     edi,320-6
                dec     ch
                jnz     @@Forj

@@NotAff:       cmp     [BouleY],30*256
                jna     @@Inc
                xor     eax,eax
                cmp     [DeplY],ax
                jng     @@Inc
                inc     al
                cmp     [FinLett],al
                jne     @@Inc
                mov     [FinLett],ah
                mov     [Start],al
                inc     [Lettre]
@@Inc:          mov     ax,[DeplX]
                add     [BouleX],ax
                mov     ax,[DeplY]
                add     [BouleY],ax
                add     [DeplY],15

@@Exit:         mov     ebx,[Randoms]
                sub     ebp,ebx
                mov     [RandPos],bp
                pop     ebp
                ret

MoveBoule       EndP

;********************************************************************
; dezoom Mandelbrot - Mandelbrot zoom out
;********************************************************************

BuildSqrMandel  Proc    Near

                mov     edi,[Carres]
                add     edi,NbSqr*4             ; Carres^[0]
                xor     eax,eax
                stosd
                mov     edx,eax
                inc     edx                     ; 1
                mov     ebx,-8
                mov     ecx,NbSqr

@@LoopSq:       add     eax,edx                 ; carre suivant                 - next square
                add     edx,2
                mov     [edi+ebx],eax
                stosd
                sub     ebx,8
                loop    @@LoopSq
                ret

BuildSqrMandel  EndP


InitMandel      Proc    Near

                mov     [JuliaJmp1],offset Mandel1
                mov     [JuliaJmp2],offset Mandel2
                mov     [JuliaJmp3],offset Mandel3
                mov     [JuliaJmp4],offset Mandel4
                mov     [JuliaJmp5],offset Mandel5
                mov     [JuliaInc1],1
                mov     [JuliaInc2],1
                ret

InitMandel      EndP


Mand_Julia      Proc    Near

                mov     eax,[Pas]               ; inits communes                - common inits
                mov     edx,eax
                imul    edx,-100
                add     ax,ax
                mov     word ptr [JuliaIncPtx],ax
                mov     word ptr [JuliaIncPty],ax
                shr     ax,1
                imul    eax,-160
                mov     ebx,eax
                mov     edi,[Ecr_Virtu]
                push    ebp
                mov     ebp,edi
                jmp     [JuliaJmp1]

Julia1:         mov     eax,[pty]
                mov     [JuliaAddPty],eax
                mov     eax,[ptx]
                mov     [JuliaAddPtx],eax
                add     ebp,320*198+319         ; symetrie centrale             - central symmetry
                jmp     @@InitsOk

Mandel1:        mov     [JuliaAddPty],edx
                add     ebx,-14000
                add     ebp,320*198             ; symetrie horizontale          - horizontal symmetry

@@InitsOk:      mov     esi,[Carres]
                mov     [JuliaMovPtx],ebx
                xor     al,al                   ; y=0
                jmp     @@Forj2                 ; vider cache                   - clear cache

@@Forj2:        and     eax,0000FFFFh           ; x=0
                mov     ecx,[JuliaMovPtx]       ; zx depart                     - zx start
                jmp     [JuliaJmp2]

Mandel2:        mov     [JuliaAddPtx],ecx

Julia2:
@@Fori2:        push    ecx
                push    edx
                jmp     [JuliaJmp3]

Mandel3:        xor     ah,ah                   ; ax=y
                cmp     ax,[Yh]
                jl      @@CalculMand
                cmp     ax,[Yb]
                jg      @@CalculMand
                mov     ebx,eax
                shr     ebx,16                  ; bx=x
                cmp     bx,[Xg]
                jl      @@CalculMand
                cmp     bx,[Xd]
                jng     @@FinRepeat

@@CalculMand:   xor     ecx,ecx
                mov     edx,ecx
                mov     ebx,ecx
                mov     esi,ecx
                jmp     @@Ink

Julia3:         sar     ecx,8
                push    ebp
                mov     ebp,[Carres]
                mov     ebx,[ecx*4+NbSqr*4+ebp] ; x2
                sar     edx,8
                mov     esi,[edx*4+NbSqr*4+ebp] ; y2
                add     ebx,esi                 ; x2+y2
                pop     ebp

@@Ink:          xor     ah,ah

@@Repeat:       add     ah,8
                cmp     ah,22*8
                jz      @@FinRepeat
                add     edx,ecx                 ; zy+zx
                push    ebp
                mov     ebp,[Carres]
                mov     edx,[edx*4+NbSqr*4+ebp] ; (zx+zy)^2
                sub     edx,ebx                 ; -(zx^2+zy^2)=>2*zx*zy
                pop     ebp
                add     edx,[JuliaAddPty]       ; automodif pty
;@@AddPty = $-4
                sar     edx,8
                sub     ebx,esi                 ; x2
                mov     ecx,ebx
                sub     ecx,esi                 ; x2-y2
                add     ecx,[JuliaAddPtx]       ; automodif ptx
                                                ; zx=x2-y2+cx
                sar     ecx,8
                push    ebp
                mov     ebp,[Carres]
                mov     esi,[edx*4+NbSqr*4+ebp] ; edx^2
                mov     ebx,[ecx*4+NbSqr*4+ebp] ; ecx^2
                add     ebx,esi
                pop     ebp
                cmp     ebx,1024*1024           ; sort du cercle ?              - exits the circle ?
                jl      @@Repeat

@@FinRepeat:    cmp     ah,11*8
                jb      @@FinRep2
                add     ah,9*8
@@FinRep2:      mov     [ebp],ah
                mov     [ebp+320],ah
                add     ebp,[JuliaInc1]
                mov     [ebp],ah
                mov     [ebp+320],ah
                add     ebp,[JuliaInc2]
                mov     [edi],ah
                mov     [edi+320],ah
                inc     edi
                mov     [edi],ah
                mov     [edi+320],ah
                inc     edi

                pop     edx                     ; recup compteurs               - get back counters
                pop     ecx
                add     ecx,[JuliaIncPtx]
                jmp     [JuliaJmp4]

Mandel4:        mov     ecx,[JuliaIncPtx]
                add     [JuliaAddPtx],ecx

Julia4:         add     eax,00020000h
                cmp     eax,01400000h
                jb      @@Fori2
                add     edi,320
                sub     ebp,320
                add     edx,[JuliaIncPty]
                jmp     [JuliaJmp5]

Mandel5:        mov     edx,[JuliaIncPty]
                add     [JuliaAddPty],edx
                sub     ebp,320*2

Julia5:         add     al,2
                cmp     al,100
                jnz     @@Forj2

                pop     ebp
                ret

Mand_Julia      EndP

;********************************************************************
; Julia
;********************************************************************

InitJulia       Proc    Near

                mov     [JuliaJmp1],offset Julia1
                mov     [JuliaJmp2],offset Julia2
                mov     [JuliaJmp3],offset Julia3
                mov     [JuliaJmp4],offset Julia4
                mov     [JuliaJmp5],offset Julia5
                mov     [JuliaInc1],-1
                mov     [JuliaInc2],-1
                mov     [Pas],178
                ret

InitJulia       EndP


MoveJulia       Proc    Near                    ; fonction: true => fin trajectoire - end of path
Local           tmp  :  WORD

                call    Mand_Julia              ; construire Julia              - build Julia
                mov     edi,[Map]
                add     edi,78*256+64
                mov     esi,[Ecr_Virtu]
                add     esi,32
                mov     ebx,100

@@Copy:         mov     ecx,128                 ; recopier dans Map 1 pt sur 2  - copy 1 of 2 pts in Map
@@Copy2:        movsb
                inc     esi
                dec     ecx
                jnz     @@Copy2
                add     esi,320-256+320
                add     edi,128
                dec     ebx
                jnz     @@Copy

                call    AfficheLand             ; construire 3D (par dessus)    - build 3D (above)
                ret

MoveJulia       EndP

;********************************************************************
; landscape
;********************************************************************

InitLand        Proc    Near

                mov     edi,[Map]
                xor     eax,eax
                mov     ecx,65536/2
                rep     stosw
                mov     [Teta],ax

                call    BuildTrigoLand

InitLand        EndP


PaletteLand     Proc    Near

                lea     edi,Dac
                add     edi,3

                xor     eax,eax
                stosw
                mov     al,63                   ; eau                 - water
                stosb

@@Verts:        mov     al,ah
                stosb
                shr     al,1
                add     al,32
                stosb
                mov     al,ah
                stosb
                add     ah,2
                cmp     ah,63
                jb      @@Verts
                jmp     SetPalette

PaletteLand     EndP


BuildLand       Proc    Near

                mov     [GermeZ],36041971h
                mov     eax,256
                push    eax
                push    eax
                xor     eax,eax
                push    eax
                push    eax
                call    BuildMapLand

                mov     [JmpTestsLand],offset NoTestsLand
                ret

BuildLand       EndP


BuildTrigoLand  Proc    Near                    ; 256*Sin - 256*Cos - 360
Local           Loader : WORD

                lea     esi,SinCos
                mov     ecx,360
                mov     [Loader],256
                fild    [Loader]
                mov     [Loader],180
                fldpi
                fidiv   [Loader]                ; pas=pi/180                    - step=pi/180
                fldz                            ; angle=0

@@BuildTLand:   fst     st(3)                   ; sauver angle                  - save angle
                fsincos
                fmul    st,st(3)                ; *256
                fistp   word ptr [esi+2]
                fmul    st,st(2)                ; *256
                fistp   word ptr [esi]
                add     esi,4
                fld     st(2)                   ; recuperer angle               - get back angle
                fadd    st,st(1)                ; + pas
                loop    @@BuildTLand

;                fstp
;                fstp
;                fstp
;                fstp
                ret

BuildTrigoLand  EndP


BuildMapLand    Proc    Near    x1 : WORD, y1 : WORD, x2 : WORD, y2 : WORD
Local           p1 : WORD, p2 : WORD, p3 : WORD, p4 : WORD, xn : WORD, yn : WORD

                pusha
                xor     ebx,ebx
                mov     ax,[y1]
                mov     bx,[x1]
                mov     cx,[y2]
                mov     dx,[x2]
                sub     dx,bx                   ; x2-x1
                sub     cx,ax                   ; y2-y1
                cmp     dx,2
                jnl     @@Sup2
                cmp     cx,2
                jl      @@Quitte

@@Sup2:         mov     bh,al
                mov     edi,[Map]
                xor     ah,ah
                mov     al,[edi+ebx]
                mov     [p1],ax                 ; Map^[y1 Shl 8+x1]
                mov     bh,byte ptr [y2]
                mov     al,[edi+ebx]
                mov     [p2],ax                 ; Map^[y2 Shl 8+x1]
                mov     bx,[x2]
                add     bh,byte ptr [y1]
                mov     al,[edi+ebx]
                mov     [p3],ax                 ; Map^[y1 Shl 8+x2]
                mov     bx,[x2]
                add     bh,byte ptr [y2]
                mov     al,[edi+ebx]
                mov     [p4],ax                 ; Map^[y2 Shl 8+x2]

                mov     ax,[x2]
                add     ax,[x1]
                shr     ax,1
                mov     [xn],ax
                mov     ax,[y2]
                add     ax,[y1]
                shr     ax,1
                mov     [yn],ax
                mov     ax,cx
                add     ax,dx                   ; x2-x1+y2-y1
                mov     cx,ax
                shl     ax,2
                add     ax,cx                   ; *5
                xor     dx,dx
                mov     cx,3
                idiv    cx                      ; /3
                mov     cx,ax                   ; dxy
                mov     si,2                    ; dvd

                mov     bx,[xn]
                mov     bh,byte ptr [y1]
                cmp     byte ptr [edi+ebx],0    ; Map^[y1 Shl 8+xn]
                jne     @@Test2
                mov     ax,[p1]
                add     ax,[p3]
                call    NCol
                mov     edi,[Map]
                mov     [edi+ebx],al
@@Test2:        mov     bx,[x1]
                mov     bh,byte ptr [yn]
                cmp     byte ptr [edi+ebx],0    ; Map^[yn Shl 8+x1]
                jne     @@Test3
                mov     ax,[p1]
                add     ax,[p2]
                call    NCol
                mov     edi,[Map]
                mov     [edi+ebx],al
@@Test3:        mov     bx,[x2]
                add     bh,byte ptr [yn]
                cmp     byte ptr [edi+ebx],0    ; Map^[yn Shl 8+x2]
                jne     @@Test4
                mov     ax,[p3]
                add     ax,[p4]
                call    NCol
                mov     edi,[Map]
                mov     [edi+ebx],al
@@Test4:        mov     bx,[xn]
                mov     bh,byte ptr [y2]
                cmp     byte ptr [edi+ebx],0    ; Map^[y2 Shl 8+xn]
                jne     @@YnXn
                mov     ax,[p2]
                add     ax,[p4]
                call    NCol
                mov     edi,[Map]
                mov     [edi+ebx],al
@@YnXn:         mov     ax,[p1]
                add     ax,[p2]
                add     ax,[p3]
                add     ax,[p4]
                add     si,si
                call    NCol
                mov     edi,[Map]
                mov     bx,[xn]
                mov     bh,byte ptr [yn]
                mov     [edi+ebx],al            ; Map^[yn Shl 8+xn]

                mov     ax,[x1]
                mov     bx,[y1]
                mov     cx,[x2]
                mov     dx,[y2]
                mov     di,[xn]
                mov     si,[yn]
                movzx   eax,ax
                movzx   ebx,bx
                movzx   ecx,cx
                movzx   edx,dx
                movzx   edi,di
                movzx   esi,si
                push    esi                     ; yn
                push    edi                     ; xn
                push    ebx                     ; y1
                push    eax                     ; x1
                call    BuildMapLand
                push    esi                     ; yn
                push    ecx                     ; x2
                push    ebx                     ; y1
                push    edi                     ; xn
                call    BuildMapLand
                push    edx                     ; y2
                push    edi                     ; xn
                push    esi                     ; yn
                push    eax                     ; x1
                call    BuildMapLand
                push    edx                     ; y2
                push    ecx                     ; x2
                push    esi                     ; yn
                push    edi                     ; xn
                call    BuildMapLand

@@Quitte:       popa
                ret

BuildMapLand    EndP


NCol            Proc    Near                   ; ax=mc, cx=n, si=dvd

                mov     di,ax                  ; mc
                movzx   ecx,cx
                push    ecx                    ; n
                call    Randm                  ; [-n;+n]
                add     ax,di                  ; +mc
                cwd
                idiv    si                     ; /dvd
                cmp     ax,255
                jng     @@UpOk
                mov     ax,255
@@UpOk:         cmp     ax,8
                jnl     @@DownOk
                mov     ax,8
@@DownOk:       ret

NCol            EndP


AfficheLand     Proc    Near
Local           steta : DWORD, cteta : DWORD
Local           x1    : DWORD, y1    : DWORD
Local           x0    : DWORD, y0    : DWORD

                lea     edi,Horiz
                mov     ax,0C8C8h               ; 200
                mov     ecx,160/2
                rep     stosw                   ; horizon bas

                xor     ebx,ebx
                mov     bx,[Teta]
                shl     bx,2
                lea     esi,[SinCos]
                add     ebx,esi
                mov     ax,[ebx]                ; steta
                cwde
                mov     [steta],eax
                imul    eax,-80
                mov     cx,[CentrY]
                shl     cx,8
                movzx   ecx,cx
                add     ecx,eax
                mov     ax,[ebx+2]              ; cteta
                cwde
                mov     [cteta],eax
                imul    eax,-100
                add     eax,ecx
                mov     [y1],eax                ; y1=-80*steta-100*cteta+CentrY*256
                mov     cx,[CentrX]
                shl     cx,8
                movzx   ecx,cx
                mov     eax,[cteta]
                imul    eax,80
                add     ecx,eax
                mov     eax,[steta]
                imul    eax,-100
                add     eax,ecx
                mov     [x1],eax                ; x1=80*cteta-100*steta+CentrX*256

                mov     esi,edi
                dec     esi                     ; Horiz [159]
                mov     ch,199+32+1             ; ch=j+1

@@AffForj:      mov     edx,[x1]                ; dx=x0
                mov     ebx,[y1]                ; bx=y0
                mov     eax,[steta]
                add     [x1],eax
                mov     eax,[cteta]
                add     [y1],eax
                mov     cl,159+1                ; cl=i+1
                mov     edi,320-2

@@AffFori:      cmp     byte ptr [esi],0
                jna     @@Next
                jmp     [JmpTestsLand]
TestsLand:      cmp ebx,178*256-1               ; y bas
                ja  @@Next2
                cmp ebx,78*256                  ; y haut
                jb  @@Next2
                cmp edx,192*256-1               ; x droit
                ja  @@Next2
                cmp edx,64*256                  ; x gauche
                jb  @@Next2
NoTestsLand:
                mov     ah,bl
                mov     bl,dh                   ; bh=Hi(y0); bl=Hi(x0)
                movzx   ebx,bx
                push    edi
                mov     edi,[Map]
                mov     al,[edi+ebx]
                pop     edi
                shr     al,3                    ; z
                mov     bl,ah
                mov     ah,ch
                dec     ah
                sub     ah,al                   ; j-z
                jnc     @@AbsOk                 ; >=0
                xor     ah,ah
@@AbsOk:        cmp     ah,[esi]                ; j-z < Horiz[i] ?
                jnb     @@Next
                xchg    ah,[esi]                ; ah=Horiz[i]
                push    ebx
                mov     bh,ah
                dec     bh
                xor     bl,bl                   ; bx=(Horiz[i]-1)*256
                push    edi
                and     ebx,0FFFFh
                add     edi,ebx
                shr     bx,2
                add     edi,ebx
                mov     bl,ah
                sub     bl,[esi]                ; compteur                      - counter
                mov     ah,al
@@AffFork:      push    esi
                mov     esi,[Ecr_Virtu]
                mov     [esi+edi],ax
                pop     esi
                sub     edi,320
                dec     bl
                jnz     @@AffFork
                pop     edi
                pop     ebx
@@Next:         sub     edi,2
                dec     esi
                sub     edx,[cteta]
                add     ebx,[steta]
                dec     cl
                jnz     @@AffFori
                add     esi,160
                dec     ch
                jnz     @@AffForj
                ret

@@Next2:        mov     ah,ch
                sub     ah,2                    ; j-z avec z=1
                jnc     @@AbsOk2                ; >=0
                xor     ah,ah
@@AbsOk2:       cmp     ah,[esi]                ; j-z < Horiz[i] ?
                jnb     @@Next
                mov     [esi],ah
                jmp     @@Next

AfficheLand     EndP

;********************************************************************
; Mandel Copro (map goutte - drop's map)
;********************************************************************

MandelCopro     Proc    Near

                mov     ch,128                  ; 128 lignes                    - 128 rows
@@CoproForj:    xor     cl,cl                   ; 256 colonnes                  - 256 columns
                mov     [LdW2],-23593-100       ; colonne 0 (160)

@@CoproFori:    fild    [LdW1]                  ; ST=lig 0
                fidiv   [LdW3]                  ; ST=lig/32768
                fild    [LdW2]                  ; ST=col 0
                fidiv   [LdW3]                  ; ST(1)=lig/32768; ST=col/32768
                fldz                            ; empiler 0=(x+y)^2             - push 0
                fldz                            ; x^2-y^2
                fldz                            ; x^2+y^2
                mov     bl,63                   ; iterations                    - loops
@@Iter:         fsubr   st,st(2)                ; st=2.x.y
                fadd    st,st(4)                ; +cy => zy
                fld     st(1)                   ; empiler x^2-y^2               - push x^2-y^2
                fadd    st,st(4)                ; +cx => zx
                fld     st(0)                   ; empiler zx                    - push zx
                fadd    st,st(2)                ; +zy
                fmul    st,st                   ; (zx+zy)^2
                fstp    st(4)                   ; ecraser ancienne valeur et depiler - replace old value and pop
                fmul    st,st                   ; zx^2
                fst     st(2)                   ; a la place de x^2-y^2         - replace x^2-y^2
                fld     st(1)                   ; empiler zy                    - push zy
                fmul    st,st                   ; zy^2
                fsub    st(3),st                ; nouveau x^2-y^2               - new x^2-y^2
                fadd    st(1),st                ; zx^2+zy^2
                fstp    st(0)
                fstp    st(1)                   ; ecraser ancienne valeur et depiler - replace old value and pop
                fild    [LdW4]                  ; max module
                fcomp
                fstsw   ax                      ; transferer les flags          - get copro flags
                sahf
                jb      @@FinRep                ; module depasse                - out of range
                dec     bl
                jz      @@FinRep                ; iterations maxi
                jmp     @@Iter

@@FinRep:       mov     al,bl
                inc     al
                stosb
                fstp    st(0)
                fstp    st(0)
                fstp    st(0)
                fstp    st(0)
                fstp    st(0)                   ; depiler 5 registres           - pop 5 registers
                inc     [LdW2]
                dec     cl
                jnz     @@CoproFori
                inc     [LdW1]
                dec     ch
                jnz     @@CoproForj
                ret

MandelCopro     EndP

;********************************************************************
; goutte mappee - textured drop
;********************************************************************

InitGoutte      Proc    Near

                call    BuildSqrGoutte
                call    BuildSqrtGoutte
                call    BuildSinGoutte
                xor     ax,ax
                mov     [Cmpt],ax
                mov     [CentrX],ax

InitGoutte      EndP


PaletteGoutte   Proc    Near

                lea     edi,Dac
                push    edi
                xor     eax,eax
                mov     ecx,256*3/4
                rep     stosd
                pop     edi
                add     edi,3

                mov     al,3Fh
@@bleus:        mov     [edi+2],al
                mov     [edi+21*3+1],al
                mov     [edi+42*3],al
                add     edi,3
                sub     al,3
                jnz     @@bleus
                call    AffiChapeau
                mov     bl,1
                call    WaitAndCopy
                jmp     SetPalette

PaletteGoutte   EndP


BuildSqrGoutte  Proc    Near

                mov     edi,[Carres2]
                mov     ebx,254-175-1           ; j initial
                mov     esi,160*160*2

@@BSqrj:        mov     ecx,160                 ; abs(xp)
                inc     bx
@@BSqrxp:       mov     eax,ecx
                mul     ebx
                shr     eax,1
                mul     eax
                div     esi
                stosw
                loop    @@BSqrxp
                inc     bx
                cmp     bx,254                  ; j=0 ?
                jbe     @@BSqrNeg
                inc     bx
@@BSqrNeg:      cmp     bx,254+255
                jbe     @@BSqrj
                ret

BuildSqrGoutte  EndP


BuildSqrtGoutte Proc    Near
Local           N     : DWORD
Local           Result : WORD

                mov     edi,[Alti]
                add     edi,AltiSize*2          ; Raci
                mov     ecx,RaciSize
                mov     [N],0                   ; 1er carre                     - 1st square
@@BuilSqrt:     fild    [N]
                fsqrt
                fistp   [Result]
                mov     ax,[Result]
                stosw
                add     [N],163*163             ; carre suivant                 - next square
                loop    @@BuilSqrt
                ret

BuildSqrtGoutte EndP


BuildSinGoutte  Proc    Near
Local           i:WORD, j:WORD, Cst:WORD, Trois:WORD ,Result:WORD

                mov     edi,[SinGoutte]
                cld
                mov     [Cst],163
                mov     [Trois],3
                mov     [i],0                   ; i
                mov     [j],4608*2              ; (4608-i)*2

@@Calcul:       fild    i
                fidiv   [Cst]                   ; i/163
                fsin                            ; Sin(i/163)
                fimul   [j]
                fidiv   [Trois]
                fistp   [Result]
                mov     ax,[Result]
                neg     ax
                stosw
                inc     [i]
                sub     [j],2
                cmp     [i],4096
                jb      @@Calcul
                ret

BuildSinGoutte  EndP


AffiChapeau     Proc    Near
Local           j:WORD, j2:WORD, k:WORD, OffHaut : DWORD

                mov     esi,[Carres2]
                mov     edi,[Alti]
                add     edi,2*AltiSize+2*RaciSize
                mov     [OffHaut],edi           ; Haut
                mov     ecx,160/4
                mov     eax,0c8c8c8c8h          ; 200
                rep     stosd                   ; initialiser horizon flottant  - initialize floating horizon

                mov     [k],-175+254
                mov     [j],-175                ; j=-175  255
                mov     ax,[j]

@@forj:         imul    ax                      ; ax=j*j
                shr     ax,3
                mov     [j2],ax                 ; j2=j^2/8
                xor     bx,bx                   ; bx=xp=0  159

@@forxp:        mov     di,[esi]                ; di=Carres^[cmp,xp]
                add     di,[j2]
                shr     di,4                    ; (i^2+j^2)/128
                add     di,di
                add     di,AltiSize*2
                movzx   edi,di
                add     edi,[Alti]
                mov     di,[edi]                ; di=SqD
                add     di,di
                movzx   edi,di
                add     edi,[Alti]
                mov     cx,[edi]                ; cx=z
                mov     ax,64*256
                sub     ax,cx                   ; ax=64*256-z
                xor     dx,dx
                mov     di,[k]
                div     di                      ; ax=yp=(64*256-z) Div k

                cmp     al,200-18               ; pour descendre a l'ecran      - to go down on the screen
                jae     @@dejapt
                add     al,18

                mov     edi,[OffHaut]           ; Haut
                movzx   ebx,bx
                mov     dl,[edi+ebx]            ; dl=Haut [xp]
                cmp     al,dl                   ; yp < Haut [xp] ?
                jae     @@dejapt

                mov     [edi+ebx],al            ; Haut [xp]=yp
                sub     dl,al                   ; nbre de lignes a remplir      - nb rows to fill
                mov     di,ax
                shl     ax,8
                shl     di,6
                add     di,ax                   ; di=320*yp

                sar     cx,7                    ; z/128
                jns     @@zposi
                neg     cl
@@zposi:        add     cl,15
                mov     ch,cl

                mov     ax,bx
                mov     bx,[k]
                shr     bx,1
                mov     bh,bl
                mov     bl,al
                shr     bl,1                    ; bx=256*(k/2)+(xp/2)
                push    esi
                mov     esi,[MapGoutte]
                movzx   ebx,bx
                mov     ch,[esi+ebx]            ; map
                neg     bl
                add     bl,160
                mov     cl,[esi+ebx]
                mov     bx,ax
                pop     esi

                sub     di,bx
                add     bx,bx
@@forl:         movzx   edi,di
                movzx   ebx,bx
                add     edi,[Ecr_Virtu]
                mov     [edi+ebx],ch            ; afficher                      - plot
                mov     [edi+319],cl            ; symetrique
                sub     edi,[Ecr_Virtu]
                add     edi,320
                dec     dl
                jnz     @@forl
                shr     bx,1

@@dejapt:       inc     bx                      ; xp+1
                add     esi,2
                cmp     bx,160
                jb      @@forxp

                mov     ax,[j]
                add     [k],2
                add     ax,2
                js      @@jnegatif
                inc     ax
                inc     [k]
@@jnegatif:     mov     [j],ax
                cmp     ax,257
                jne     @@forj

                mov     edi,[Ecr_Virtu]
                mov     eax,0F0F0F0Fh
                mov     cx,50*320/4
                rep     stosd                   ; effacer 50 lignes             - clear 50 rows
                ret

AffiChapeau     EndP


DecaleAlti      Proc    Near

                mov     edi,[Alti]
                mov     esi,[Alti]
                add     edi,(AltiSize-1)*2
                add     esi,(AltiSize-1-32)*2
                std
                mov     ecx,AltiSize-1-31
                rep     movsw
                cld
                ret

DecaleAlti      EndP


CreeGoutte      Proc    Near

                mov     edi,[Alti]
                add     edi,31*2                 ; Alti^[31-0]
                mov     ecx,32                   ; i
                mov     esi,[SinGoutte]
                xor     ebx,ebx
                mov     bx,[Cmpt]
                add     ebx,ebx
                add     esi,ebx                  ; Sinus^[Cmpt]

@@GouttFori:    cmp     bx,4096
                ja      @@Zero
                mov     ax,[esi]
                add     esi,2
                mov     [edi],ax
                sub     edi,2
                inc     bx
                loop    @@GouttFori
                jmp     @@Sortie

@@Zero:         xor     ax,ax
                mov     [edi],ax
                sub     edi,2
                loop    @@Zero

@@Sortie:       ret

CreeGoutte      EndP

;********************************************************************
; OpenGL
;********************************************************************

glResize        Proc    w,h

                _glViewport     0,0,w,h
                invoke  glClear,GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT
                ret

glResize        EndP


SetupOpenGL     Proc    hWnd
Local           pfd       : PIXELFORMATDESCRIPTOR
Local           pixformat : DWORD

                invoke  GetDC,hWnd
                mov     hdc,eax

                ZeroMemory &pfd,sizeof(PIXELFORMATDESCRIPTOR)
                mov     pfd.nSize,sizeof(PIXELFORMATDESCRIPTOR)
                mov     pfd.nVersion,1
                mov     pfd.dwFlags,PFD_SUPPORT_OPENGL OR PFD_DOUBLEBUFFER OR PFD_DRAW_TO_WINDOW
                mov     pfd.iPixelType,PFD_TYPE_RGBA
                mov     pfd.cColorBits,16
                mov     pfd.cDepthBits,16
                mov     pfd.iLayerType,PFD_MAIN_PLANE
                invoke  ChoosePixelFormat,hdc,ADDR pfd
                mov     pixformat,eax
                invoke  SetPixelFormat,hdc,pixformat,ADDR pfd

                invoke  wglCreateContext,hdc
                mov     hrc,eax
                invoke  wglMakeCurrent,hdc,hrc

                _glClearColor     0.f,0.f,0.f,0.f
                _glDisable        GL_DEPTH_TEST
                _glDisable        GL_ALPHA_TEST
                _glDisable        GL_BLEND
                _glDisable        GL_DITHER
                _glDisable        GL_FOG
                _glDisable        GL_LIGHTING
                _glDisable        GL_LOGIC_OP
                _glDisable        GL_STENCIL_TEST
                _glDisable        GL_TEXTURE_1D
                _glDisable        GL_TEXTURE_2D
                _glPixelTransferi GL_MAP_COLOR,   GL_FALSE
                _glPixelTransferi GL_RED_SCALE,   1
                _glPixelTransferi GL_RED_BIAS,    0
                _glPixelTransferi GL_GREEN_SCALE, 1
                _glPixelTransferi GL_GREEN_BIAS,  0
                _glPixelTransferi GL_BLUE_SCALE,  1
                _glPixelTransferi GL_BLUE_BIAS,   0
                _glPixelTransferi GL_ALPHA_SCALE, 1
                _glPixelTransferi GL_ALPHA_BIAS,  0
                ret

SetupOpenGL     EndP


KillOpenGL      Proc

                invoke  wglMakeCurrent,NULL,NULL
                invoke  wglDeleteContext,hrc
                invoke  ReleaseDC,hWindow,hdc
                invoke  ChangeDisplaySettings, NULL,0
                ret

KillOpenGL      EndP


GL_Paint        Proc

                invoke  glPixelStorei,GL_UNPACK_ALIGNMENT,1
                mov     edi,[Ecr_Virtu2]
                invoke  glRasterPos2i, -1,-1
                invoke  glDrawPixels,320,200,GL_RGB,GL_UNSIGNED_BYTE,edi
                add     edi,320*200*3
                invoke  glRasterPos2i, -1,0
                invoke  glDrawPixels,320,200,GL_RGB,GL_UNSIGNED_BYTE,edi
                add     edi,320*200*3
                invoke  glRasterPos2i, 0,-1
                invoke  glDrawPixels,320,200,GL_RGB,GL_UNSIGNED_BYTE,edi
                add     edi,320*200*3
                invoke  glRasterPos2i, 0,0
                invoke  glDrawPixels,320,200,GL_RGB,GL_UNSIGNED_BYTE,edi
                invoke  SwapBuffers,hdc
                ret

GL_Paint        Endp

;********************************************************************
; Win32
;********************************************************************

ALIGN 4

MainWinProc     Proc    hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
Local           crect : RECT
Local           ps    : PAINTSTRUCT

                mov     eax,uMsg

                .if     eax==WM_CREATE
                  invoke SetupOpenGL,hWnd
                  invoke GetClientRect,hWnd,ADDR crect
                  invoke glResize,crect.right,crect.bottom
                  sub    eax,eax

                .elseif eax==WM_KEYDOWN
                  .if     wParam==VK_ESCAPE
                    call  TextScreen2
                    lea   edi,Dac
                    mov   ecx,256*3/4
                    xor   eax,eax
                    rep   stosd
                    invoke PostMessage,hWnd,WM_CLOSE,NULL,NULL

                  .elseif wParam==VK_RETURN
                    mov   [_enter],1
                  .endif

                  sub eax,eax

                .elseif eax==WM_DESTROY
                  call  KillOpenGL
                  invoke PostQuitMessage,0

                .elseif eax==WM_ACTIVATEAPP
                  push  wParam
                  pop   Activity
                  xor   eax,eax                 ; we should return zero!

                .elseif eax==WM_SIZE
                  .if   hrc
                    invoke GetClientRect,hWnd,ADDR crect
                    invoke glResize,crect.right,crect.bottom
                  .endif

                  sub eax,eax

                .elseif eax==WM_PAINT
                  invoke BeginPaint,hWnd,ADDR ps
                  mov   al,[TextScreen]
                  .if al==1
                    call DrawText1
                  .elseif al==2
                    call DrawText2
                  .elseif al==3
                    call DrawText3
                  .endif 
                  invoke EndPaint,hWnd,ADDR ps
                  sub eax,eax

                .else
                  invoke DefWindowProc,hWnd,uMsg,wParam,lParam
                .endif
                ret

MainWinProc     Endp


ALIGN 4

InitScreen      Proc    hInst:DWORD, prevInstance:DWORD, cmdlinePtr:DWORD, cmdShow:DWORD
Local           wc    : WNDCLASSEX
Local           dm    : DEVMODE

; from WinGdi.h
DM_BITSPERPEL   equ     00040000h
DM_PELSWIDTH    equ     00080000h
DM_PELSHEIGHT   equ     00100000h

                lea     edi,dm
                sub     eax,eax
                mov     ecx,sizeof DEVMODE
                rep     stosb
                mov     dm.dmSize, sizeof DEVMODE
                mov     dm.dmPelsWidth,  640
                mov     dm.dmPelsHeight, 400
                mov     dm.dmBitsPerPel, 32
                mov     dm.dmFields, DM_BITSPERPEL OR DM_PELSWIDTH OR DM_PELSHEIGHT
;                invoke  ChangeDisplaySettings, ADDR dm, CDS_FULLSCREEN          ; fullscreen

                lea     edi,wc
                sub     eax,eax
                mov     ecx,(sizeof WNDCLASSEX)/4
                rep     stosd
                mov     eax,hInst
                mov     hInstance,eax
                mov     wc.hInstance,eax
                mov     wc.cbSize, sizeof WNDCLASSEX
                mov     wc.style,CS_OWNDC or CS_HREDRAW or CS_VREDRAW
                mov     wc.lpszClassName,offset MyClassName
                mov     wc.lpfnWndProc,offset MainWinProc
                invoke  LoadCursor,NULL,IDC_ARROW
                mov     wc.hCursor,eax
                mov     wc.hbrBackground,COLOR_GRAYTEXT
                invoke  RegisterClassEx,ADDR wc

                sub     eax,eax
                invoke  CreateWindowEx,NULL,ADDR MyClassName,ADDR WinTitleString,WS_OVERLAPPED OR WS_CAPTION OR WS_SYSMENU OR WS_CLIPCHILDREN OR WS_CLIPSIBLINGS,16,16,320*2+6,200*2+25,eax,eax,hInst,eax
;                invoke  CreateWindowEx, WS_EX_TOOLWINDOW, ADDR MyClassName, ADDR WinTitleString, WS_POPUP OR WS_CLIPSIBLINGS OR WS_CLIPCHILDREN OR WS_VISIBLE, 0, 0, 640, 400, 0, 0, hInst, 0
                mov     hWindow,eax
                invoke  ShowWindow,eax,SW_SHOWDEFAULT
                invoke  UpdateWindow,hWindow
                ret

InitScreen      EndP


TestKeys        Proc
Local           msg   : MSG

@@winmainmsgloop:                               ;enter message dispatching loop
                sub     eax,eax
                lea     edi,msg
                invoke  PeekMessage,edi,eax,eax,eax,PM_REMOVE
                test    eax,eax
                jz      @@End

                mov     eax,msg.message
                cmp     eax,WM_QUIT
                je      @@quitmsgposted

                push    edi
                push    edi
                call    TranslateMessage
                call    DispatchMessage
                jmp     @@winmainmsgloop

@@End:          ret
EVEN
@@quitmsgposted:invoke  VirtualFree,Ecr_Virtu,0,MEM_RELEASE
                invoke  ExitProcess,0
                ret

TestKeys        EndP


ReserveMem      Proc

                lea     edi,firstvar
                lea     ecx,lastvar
                sub     ecx,edi
                sub     eax,eax
                rep     stosb                   ; clear all variables

                invoke  VirtualAlloc,NULL,MemNeeded*16,MEM_RESERVE or MEM_COMMIT,PAGE_READWRITE
                mov     edi,eax
                mov     [Ecr_Virtu],eax
                mov     ecx,4096*16
                add     eax,ecx
                mov     [Ecr_Virtu2],eax
                mov     ebx,ecx
                imul    ebx,3*4
                add     eax,ebx
                mov     [Map],eax
                add     eax,ecx
                mov     [MapGoutte],eax
                add     eax,ecx
                mov     [Randoms],eax
                add     eax,ecx
                mov     [Carres],eax
                add     eax,3251*16
                mov     [Alti],eax
                add     eax,1355*16
                mov     [Carres2],eax
                add     eax,3480*16
                mov     [Feu],eax
                add     eax,2000*16
                mov     [SinGoutte],eax

                mov     [GermeZ],12345678h
                mov     edi,[Randoms]
                mov     ecx,32768
Random:         push    1
                call    Randm
                inc     ax
                jz      Zero
                mov     al,100                  ; 0 ou 100
Zero:           stosw
                loop    Random

                clc
                ret

ReserveMem      EndP


TextScreen1     Proc

                mov     [TextScreen],1
                invoke  InvalidateRect,hWindow,NULL,FALSE
                call    TestKeys
                invoke  Sleep,3000

                mov     [TextScreen],2
                invoke  InvalidateRect,hWindow,NULL,FALSE
                call    TestKeys
                invoke  Sleep,3000
                ret

TextScreen1     ENDP


DrawText1       Proc

                invoke  glClear,GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT
                invoke  SwapBuffers,hdc
                mov     eax,00c0c0c0h
                invoke  SetTextColor,hdc,eax
                xor     eax,eax
                invoke  SetBkColor,hdc,eax
                invoke  TextOut, hdc,270,150,ADDR RealTime,10
                mov     [TextScreen],0
                ret

DrawText1       EndP


DrawText2       Proc

                invoke  TextOut, hdc,280,200,ADDR Presents,8
                mov     [TextScreen],0
                ret

DrawText2       EndP


TextScreen2     Proc

                mov     [TextScreen],3
                invoke  InvalidateRect,hWindow,NULL,FALSE
                call    TestKeys
                invoke  Sleep,4000
                ret

TextScreen2     EndP


DrawText3       Proc

                invoke  glClear,GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT
                invoke  SwapBuffers,hdc
                mov     eax,00c0c0c0h
                invoke  SetTextColor,hdc,eax
                xor     eax,eax
                invoke  SetBkColor,hdc,eax
                invoke  TextOut, hdc,0,0,ADDR CodeBy,31
                invoke  TextOut, hdc,20,16,ADDR WinVersion,25
                mov     [TextScreen],0
                ret

DrawText3       EndP

;********************************************************************
; procedures generales - general procedures
;********************************************************************

AffichAndWait   Proc    Near

                call    AfficheLand
                mov     bl,2

AffichAndWait   EndP


WaitAndCopy     Proc
Local           ps    : PAINTSTRUCT

                push    ebx

; scale from 320*200 to 640*400        13
; buffers are in the following order : 02

                mov     esi,[Ecr_Virtu]
                mov     edi,[Ecr_Virtu2]
                lea     ebx,[Dac]
                mov     ecx,200                 ; src rows
                xor     eax,eax
                add     edi,(400-1)*320*3
                call    ScaleBuffer

                mov     esi,[Ecr_Virtu]
                add     esi,160
                mov     edi,[Ecr_Virtu2]
                mov     ecx,200                 ; src rows
                add     edi,(400-1)*320*3+400*320*3
                call    ScaleBuffer

                call    GL_Paint
                pop     ebx

@@Wait:         call    timeGetTime             ; eax=result
                sub     eax,[TimeGetTime]
                add     [TimeGetTime],eax
                add     [HSec],ax
                mov     cx,[HSec]
                shr     cx,4
                cmp     cl,bl
                jb      @@Wait

                mov     [HSec],0
                ret

WaitAndCopy     EndP


ScaleBuffer     Proc

@@Ligne:        push    ecx
                mov     ecx,160                 ; src columns

@@ConvertRGB:   lodsb
                xor     edx,edx
                mov     dl,al
                add     edx,edx
                add     edx,eax                 ; *3
                mov     al,[ebx+edx]            ; R [0;63]
                shl     al,2
                mov     [edi+3],al
                mov     [edi+0-320*3],al
                mov     [edi+3-320*3],al
                stosb

                mov     al,[ebx+edx+1]          ; G
                shl     al,2
                mov     [edi+3],al
                mov     [edi+0-320*3],al
                mov     [edi+3-320*3],al
                stosb

                mov     al,[ebx+edx+2]          ; B
                shl     al,2
                mov     [edi+3],al
                mov     [edi+0-320*3],al
                mov     [edi+3-320*3],al
                stosb

                add     edi,3
                loop    @@ConvertRGB

                sub     edi,320*3*3
                add     esi,160
                pop     ecx
                loop    @@Ligne
                ret

ScaleBuffer     EndP


MoveAndWait     Proc    Near
                call    MoveJulia
                mov     bl,1
                jmp    WaitAndCopy
MoveAndWait     EndP


Defading        Proc    Near
                cmp     [_enter],0
                jnz     @@DefadEnd
                mov     ecx,63
@@OneStep:      lea     edi,Dac
                mov     ebx,256*3-1
@@OneByte:      cmp     byte ptr [edi+ebx],0
                jz      @@NextByte
                dec     byte ptr [edi+ebx]
@@NextByte:     dec     ebx
                jnz     @@OneByte
                push    ecx
                call    SetPalette
                mov     bl,1
                call    WaitAndCopy
                pop     ecx
                loop    @@OneStep
@@DefadEnd:
                ret
Defading        EndP


Randm           Proc    Val : WORD

                pushad

                mov     ebx,127773
                mov     eax,[GermeZ]
                xor     edx,edx
                div     ebx                     ; edx=z Mod 127773 et eax=z Div 127773
                mov     ecx,edx                 ; ecx=z Mod 127773
                mov     ebx,2836
                mul     ebx                     ; eax=(z Div 127773)*2836
                mov     [hlp],eax
                mov     eax,ecx                 ; eax=z Mod 127773
                mov     ebx,16807
                mul     ebx                     ; eax=16807*(z Mod 127773)
                sub     eax,[hlp]               ; eax=16807*(z Mod 127773)-2836*(z Div 127773)
                jns     @@Pas_negrm
                add     eax,2147483647
@@Pas_negrm:
                mov     [GermeZ],eax
                xor     ebx,ebx
                mov     bx,[Val]
                add     bx,bx                   ; ebx=2*no
                mul     ebx                     ; edx:eax=z*no
                mov     ebx,2147483647
                div     ebx                     ; ax=Lo(Trunc(z/2147483647*no))
                sub     ax,[Val]

                mov     word ptr [hlp],ax
                popad
                mov     ax,word ptr [hlp]
                ret

Randm           EndP

;********************************************************************
; main (entry point)
;********************************************************************

IntroFli:
                call    ReserveMem

                invoke  GetModuleHandle,NULL    ; get hInstance
                sub     edx,edx
                invoke  InitScreen,eax,edx,edx,edx

                call    TextScreen1
                call    timeGetTime
                mov     [TimeGetTime],eax
                call    TestKeys

;*** titre-feu ***

                call    InitFeu
                mov     [_enter],0
@@Feu:          call    ProcessFlammes
                mov     bl,1
                call    WaitAndCopy             ; cx=nb vbls
                movzx   ecx,cx
@@AvanceFeu:    push    ecx
                call    MoveBoule
                cmp     [FinLett],1
                je      @@NoLines
                call    BuildLines
@@NoLines:      mov     al,[Boule]
                cmp     al,5
                jbe     @@TraceFeu
                and     al,1
                jnz     @@NoTraceFeu
@@TraceFeu:     call    TraceLinesFeu
@@NoTraceFeu:   pop     ecx
                cmp     [Boule],18
                jae     @@Mandel
                loop    @@AvanceFeu
                call    TestKeys
                cmp     [_enter],0
                jz      @@Feu

;*** dezoom ***

@@Mandel:       call    BuildSqrMandel
                call    InitMandel              ; init auto-modif
                mov     [_enter],0
@@Dezoom:       call    Mand_Julia
                mov     bl,1                    ; nb vbls mini
                call    WaitAndCopy
                movzx   ecx,cx
@@AvanceZoomM:  dec     [Cmpt]
                mov     ax,word ptr [Pas]
                shr     ax,5
                add     word ptr [Pas],ax
                mov     ax,[Cmpt]
                mov     bx,ax
                shr     ax,5
                add     [Xg],ax
                sub     [Xd],ax
                cmp     bx,110
                jnb     @@WindowOk
                shr     ax,1
                sub     [Xg],ax
                add     [Xd],ax
@@WindowOk:     mov     ax,bx
                mov     ch,48
                div     ch
                xor     ah,ah
                add     [Yh],ax
                sub     [Yb],ax
                or      bx,bx
                jz      @@Julia
                sub     cl,4
                jnc     @@AvanceZoomM
                call    TestKeys
                cmp     [_enter],0
                jz      @@Dezoom

;*** Julia ***

@@Julia:        call    InitLand
                mov     [JmpTestsLand],offset TestsLand
                call    InitJulia
                mov     [_enter],0
@@ZoomJulia:    call    Mand_Julia
                mov     bl,1
                call    WaitAndCopy
                movzx   ecx,cx
@@AvanceZoomJ:  add     [Pas],20
                cmp     [Pas],678
                jae     @@InitMove
                sub     cl,3
                jnc     @@AvanceZoomJ           ; synchro timer
                call    TestKeys
                cmp     [_enter],0
                jz      @@ZoomJulia

@@InitMove:     mov     [Pas],678
                call    MoveAndWait
                movzx   ecx,cx
                mov     [TetaRets],cl           ; save nb vbls
                mov     [_enter],0
@@MoveJulia:    call    MoveAndWait
                mov     cl,[TetaRets]
@@AvanceMoveJ:  mov     eax,[dtx]
                add     [ptx],eax
                mov     eax,[dty]
                add     [pty],eax
                dec     [NbRep]
                jnz     @@Encore

                mov     bl,[PtTraj]
                inc     bl
                and     bl,7
                jz      @@InitLand
                mov     [PtTraj],bl
                xor     bh,bh
                imul    bx,6

                lea     esi,TrajJulia
                and     ebx,0FFFFh
                add     ebx,esi

                mov     ax,[ebx]
                cwde
                mov     [dtx],eax
                mov     ax,[ebx+2]
                cwde
                mov     [dty],eax
                mov     ax,[ebx+4]
                mov     [NbRep],ax

@@Encore:       mov     ax,[Teta]
                inc     ax
                inc     ax
                mov     bx,360
                cmp     ax,bx
                jb      @@Mod360_1
                sub     ax,bx
@@Mod360_1:     mov     [Teta],ax
                sub     cl,5
                jnc     @@AvanceMoveJ
                call    TestKeys
                cmp     [_enter],0
                jz      @@MoveJulia

;*** land ***

@@InitLand:     call    InitLand
                call    BuildLand
                xor     ax,ax
                mov     [Cmpt],ax
                mov     [HSec],ax
                call    AffichAndWait
                movzx   ecx,cx
                mov     [TetaRets],cl           ; save nb vbls
                mov     [_enter],0
@@Land:         call    AffichAndWait
                mov     cl,[TetaRets]
@@AvanceLand:   mov     ax,[Teta]
                inc     ax
                inc     ax
                mov     bx,360
                cmp     ax,bx
                jb      @@Mod360_2
                sub     ax,bx
                inc     [Cmpt]
@@Mod360_2:     mov     [Teta],ax
                mov     ax,2
                add     [CentrX],ax
                add     [CentrY],3
                inc     ax
                cmp     [Cmpt],ax
                je      @@Goutte
                sub     cl,4
                jnc     @@AvanceLand
                call    TestKeys
                cmp     [_enter],0
                jz      @@Land

;*** goutte ***

@@Goutte:       mov     edi,[MapGoutte]
                call    MandelCopro             ; calculate 1/2 map each time
                call    MandelCopro
                call    Defading
                call    InitGoutte
                mov     [_enter],0
@@GouttLoop:    call    AffiChapeau
                mov     bl,1
                call    WaitAndCopy
                movzx   ecx,cx
@@AvanceGoutte: push    ecx
                call    DecaleAlti
                call    CreeGoutte
                mov     ax,[Cmpt]
                add     ax,32
                cmp     ax,9000
                jb      @@NotNew
                xor     ax,ax
                inc     [CentrX]
@@NotNew:       mov     [Cmpt],ax
                cmp     [CentrX],3              ; 3 drops
                pop     ecx
                jae     @@Defade
                sub     cl,4
                jnc     @@AvanceGoutte
                call    TestKeys
                cmp     [_enter],0
                jz      @@GouttLoop

@@Defade:       call    Defading
                call    TextScreen2
                lea     edi,Dac
                mov     ecx,256*3/4
                xor     eax,eax
                rep     stosd
                jmp     @@quitmsgposted


                .STACK  2048

                END     IntroFli
